;header
Function Header(html,setcookie$="")
	;HTTP HEADER
	WriteLine html, "HTTP/1.1 200 OK"
	WriteLine html, "Server: CuccosTools/"+VERSION$
;	ServerTime(html)
;	If no_cache=0
;		WriteLine html, "Last-Modified: "+last_modified$
;		WriteLine html, "Expires: "+last_modified$
;	Else
;		WriteLine html, "Cache-Control: no-cache"
;	EndIf
	WriteLine html, "Connection: close"
;	WriteLine html, "X-Powered-By: BlitzBasic/1.68"
	If setcookie$<>"" Then WriteLine html, "Set-Cookie: cucco="+setcookie$+"; path=/" ; session cookie
	WriteLine html, "Content-Type: text/html; charset=utf-8"
	WriteLine html, ""
	;HTML HEADER
	WriteLine html, "<!DOCTYPE HTML PUBLIC "+Chr(34)+"-//W3C//DTD HTML 4.01 Transitional//EN"+Chr(34)+" "+Chr(34)+"http://www.w3.org/TR/html4/loose.dtd"+Chr(34)+">"
	WriteLine html, "<html>"
	WriteLine html, "<head>"
	WriteLine html, "<title>Pirate Tools</title>"
;	;STYLE SHEET
;	WriteLine html, "<link rel="+Chr(34)+"stylesheet"+Chr(34)+" type="+Chr(34)+"text/css"+Chr(34)+" href="+Chr(34)+"css"+Chr(34)+">"
	WriteLine html, "</head>"
	;PAGE HEADER
	WriteLine html, "<body>"
	WriteLine html, "<a href="+Chr(34)+"/"+Chr(34)+">Index</a>"
;	If user$<>"" Then WriteLine html, " ... User <b>"+user$+"</b> ... <a href="+Chr(34)+"logout"+Chr(34)+">Logout</a>"
	WriteLine html, "<hr>"
End Function

;included at the bottom of every page
Function Footer(html)
	WriteLine html, "<hr>"
	WriteLine html, "Date <b>"+CurrentDate$()+"</b> ... "
	WriteLine html, "Time <b>"+CurrentTime$()+"</b> ... "
	WriteLine html, "Took <b>"+(MilliSecs()-timer)+"ms</b>"
	WriteLine html, "</body>"
	WriteLine html, "</html>"
	WriteLine html, ""
End Function


;Function ServerTime(stream)
;	Local time$,date$,weekday$,day,mon$,month,year
;	Local c,d,m,y
;	
;	;; capture date and time
;	time$=CurrentTime$()
;	date$=CurrentDate$()
;	
;	;; parse date string
;    day = Left(date$, Instr(date$, " ") - 1)
;    year = Mid(date$, Instr(date$, " ", Instr(date$, " ")+1)+1, 4)
;    mon$ = Mid(date$, Instr(date$, " ")+1, 3)
;
;	;; get month number from month name
;    Select Upper$(mon$)
;        Case "JAN" : month = 1
;        Case "FEB" : month = 2
;        Case "MAR" : month = 3
;        Case "APR" : month = 4
;        Case "MAY" : month = 5
;        Case "JUN" : month = 6
;        Case "JUL" : month = 7
;        Case "AUG" : month = 8
;        Case "SEP" : month = 9
;        Case "OCT" : month = 10
;        Case "NOV" : month = 11
;        Case "DEC" : month = 12
;    End Select
;
;	;; get day of week
;	c=(14-month)/12
;	y=year-c
;	m=month+(12*c)-2
;	d=(day+y+(y/4)-(y/100)+(y/400)+((31*m)/12)) Mod 7
;	Select d
;		Case 0 : weekday$="Sun"
;		Case 1 : weekday$="Mon"
;		Case 2 : weekday$="Tue"
;		Case 3 : weekday$="Wed"
;		Case 4 : weekday$="Thu"
;		Case 5 : weekday$="Fri"
;		Case 6 : weekday$="Sat" 
;	End Select
;	
;	;; http format date
;	WriteLine stream, "Date: "+weekday$+", "+date$+" "+time$+" GMT"
;
;End Function


;soft error page
Function ErrorPage(html,error$)
	Header(html)
	WriteLine html, "<h1>Error!</h1>"
	WriteLine html, "<h2>"+error$+"</h2>"
	WriteLine html, "<p>Return to the <a href="+Chr(34)+"/"+Chr(34)+">Index</a></p>"
	Footer(html)
End Function


;hard 404 error
Function NotFound(html)
	WriteLine html, "HTTP/1.1 404 Not Found"
	WriteLine html, "Server: CuccosTools/"+VERSION$
;	WriteLine html, "Cache-Control: no-cache"
	WriteLine html, "Connection: close"
;	WriteLine html, "X-Powered-By: BlitzBasic/1.68"
	WriteLine html, ""
	WriteLine html, "404 Not Found"
End Function


;page already cached
;Function NotModified(html)
;	WriteLine html, "HTTP/1.1 304 Not Modified"
;	WriteLine html, "Server: CuccosTools/"+VERSION$
;End Function




;;redirect
;Function LoginRedirectPage(html,setcookie$)
;	Header(html,setcookie$,1)
;	WriteLine html, "<h1>Welcome "+user$+"</h1>"
;	WriteLine html, "<h2>Proceed to the <a href="+Chr(34)+"/"+Chr(34)+">Index</a></h2>"
;	Footer(html)
;End Function


;index page
Function IndexPage(html,setcookie$="")

;	If setcookie$<>"" Then
;		Header(html,setcookie$) ;login header
;	Else
		Header(html,"")
;	EndIf
;	
	WriteLine html, "<h1>Pirate Tools</h1>"
	WriteLine html, "<p>A database and 'tools' for <a href=" + Chr$(34) + "http://www.inselkampf.com" + Chr$(34) + ">Inselkampf.com</a> World 2. The site aims to provide more detailed information for players, but will not automate - and is completely separate from - the game (you will not be banned for using these tools).</p>"
	WriteLine html, "<p style="+Chr(34)+"color:red"+Chr(34)+">Disable referrer logging before clicking any links to the game.</p>"

;	;show specific info for user
;	For p.player = Each player
;		If p\name$[0] = user$ ;this is the player logged on
;			WriteLine html, "<h2>"+user$+"</h2>"
;			WriteLine html, "<b>Alliance:</b> ["+p\alliancetag$[0]+"] ... <b>Islands:</b> "+p\islands[0]+" ... <b>Score:</b> "+p\score[0]+" ... <b>Rank:</b> "+p\rank[0]+" ... "
;			WriteLine html, "<a href="+Chr(34)+"history?playerid="+ p\id +Chr(34)+">My History</a><br>"
;		EndIf
;	Next
	
	WriteLine html, "<table><tr><td><h2>Search</h2></td><td>"
	WriteLine html, "<a href="+Chr(34)+"search?alliances"+Chr(34)+">Alliance Search</a> ... "	
	WriteLine html, "<a href="+Chr(34)+"search?players"+Chr(34)+">Player Search</a> ... "
	WriteLine html, "<a href="+Chr(34)+"search?islands"+Chr(34)+">Island Search</a> ... "
	WriteLine html, "<a href="+Chr(34)+"search?inactive"+Chr(34)+">Inactive Finder</a>"

	WriteLine html, "</td><tr><td><h2>History</h2></td><td>"	
	WriteLine html, "<a href="+Chr(34)+"history?alliances"+Chr(34)+">Alliance History</a> ... "	
	WriteLine html, "<a href="+Chr(34)+"history?players"+Chr(34)+">Player History</a> ... "
	WriteLine html, "<a href="+Chr(34)+"history?islands"+Chr(34)+">Island History</a> ... "
	WriteLine html, "<a href="+Chr(34)+"stats"+Chr(34)+">Database Info</a>"

;	WriteLine html, "</td><tr><td><h2>Kampf</h2></td><td>"
;	WriteLine html, "<a href="+Chr(34)+"spy"+Chr(34)+">Reports</a>"
;;	WriteLine html, "<a href="+Chr(34)+"colo"+Chr(34)+">Colo Claims</a>"	

	WriteLine html, "</td><tr><td><h2>Maps</h2></td><td>"
	WriteLine html, "<a href="+Chr(34)+"map?alliances"+Chr(34)+">Alliance Maps</a> ... "	
	WriteLine html, "<a href="+Chr(34)+"map?players"+Chr(34)+">Player Maps</a>"
;	WriteLine html, "<a href="+Chr(34)+"http://s28.photobucket.com/albums/c242/flying_cucco/ik"+Chr(34)+">Really Big Map</a>"

	WriteLine html, "</td><tr><td><h2>Graphs</h2></td><td>"
	WriteLine html, "<a href="+Chr(34)+"graph?alliances"+Chr(34)+">Alliance Graphs</a> ... "	
	WriteLine html, "<a href="+Chr(34)+"graph?players"+Chr(34)+">Player Graphs</a>"

	WriteLine html, "</td><tr><td><h2>Planner</h2></td><td>"
	WriteLine html, "<a href="+Chr(34)+"calc?ocean=1&amp;sector=1&amp;isle=1"+Chr(34)+">Distance</a> ... "
	WriteLine html, "<a href="+Chr(34)+"calc?build"+Chr(34)+">Schedule</a> ... "
	WriteLine html, "<a href="+Chr(34)+"http://www.greatplay.net/ik/inselplanner.html"+Chr(34)+">Space</a> (greatplay.net) ... "
	WriteLine html, "<a href="+Chr(34)+"http://www.rulax.es/planner.php"+Chr(34)+">Space</a> (rulax.es)"

	WriteLine html, "</td><tr><td><h2>Links</h2></td><td>"
;	WriteLine html, "<a href="+Chr(34)+"http://www.inselkampf.com/"+Chr(34)+">Inselkampf</a> ... "
	WriteLine html, "<a href="+Chr(34)+"http://editthis.info/inselkampf/W2"+Chr(34)+">Wiki</a> ... "
	WriteLine html, "<a href="+Chr(34)+"http://z10.invisionfree.com/IKC/"+Chr(34)+">Forum</a>"

	WriteLine html,	"</td></table>"
	
	Footer(html)
End Function	

;search for an alliance
Function SearchAlliancePage(stream)
	Header(stream)

	WriteLine stream, "<h1>Alliance Search</h1>"
	WriteLine stream, "Search for alliances by using various <b>filters</b>. To apply a filter, enter a value in the textbox, blank filters will be ignored. Only results matching all the filter conditions will be shown, selecting no filters will list <b>everything</b>. You can apply any combination of filters, but be warned that some are mutually exclusive. When you are done, click <b>search!</b><br><br>"
	WriteLine stream, "<form name="+Chr$(34)+"alliancesearch"+Chr$(34)+" action="+Chr$(34)+"alliance"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>&nbsp;</th><td>Results</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"res"+Chr$(34)+" value="+Chr$(34)+"100"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"2"+Chr$(34)+"><h2>History</h2> Search old data.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days ago (0 is current)</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"date"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Alliance</h2>Search by alliance info.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Alliance ID</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"allianceid"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Alliance tag</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"alliancetag"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Match part of tag</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"alliancetag_search"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Score</h2> Search by total score.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"score"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"score_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"score_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Rank</h2> Search by world ranking.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals (lower is better)</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"rank"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"rank_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"rank_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Members</h2> Search by number of members.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"members"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"members_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"members_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Islands</h2> Search by number of islands.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"islands"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"islands_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"islands_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"5"+Chr$(34)+"><h2>Hunter</h2>Search for potential targets.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days inactive at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days inactive at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_most"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Points/players at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Points/players at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "</table>"
	WriteLine stream, "<br>"
	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Search!"+Chr$(34)+">"
	WriteLine stream, "</form>"

	Footer(stream)
End Function




Function SearchPlayerPage(stream)
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Search players page
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	Header(stream)

	WriteLine stream, "<h1>Player Search</h1>"
	WriteLine stream, "Search for players by using various <b>filters</b>. To apply a filter, enter a value in the textbox, blank filters will be ignored. Only results matching all the filter conditions will be shown, selecting no filters will list <b>everything</b>. You can apply any combination of filters, but be warned that some are mutually exclusive. When you are done, click <b>search!</b><br><br>"

	WriteLine stream, "<form name="+Chr$(34)+"playersearch"+Chr$(34)+" action="+Chr$(34)+"player"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>&nbsp;</th><td>Results</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"res"+Chr$(34)+" value="+Chr$(34)+"100"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"2"+Chr$(34)+"><h2>History</h2> Search old data.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days ago (0 is current)</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"date"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Player</h2>Search by player info.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Player ID</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"playerid"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Player name</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"playername"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Match part of name</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"playername_search"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Score</h2> Search by total score.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"score"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"score_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"score_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Rank</h2> Search by world ranking.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals (lower is better)</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"rank"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"rank_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"rank_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"3"+Chr$(34)+"><h2>Alliance</h2> Seach by alliance membership.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Alliance ID (0 is no alliance)</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"allianceid"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Alliance tag</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"alliancetag"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Islands</h2> Search by number of islands.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Equals</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"islands"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"islands_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"islands_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"5"+Chr$(34)+"><h2>Hunter</h2>Search for potential targets.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days inactive at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days inactive at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_most"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Points/isles at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Points/isles at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "</table>"
	WriteLine stream, "<br>"
	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Search!"+Chr$(34)+">"
	WriteLine stream, "</form>"

	Footer(stream)
End Function






;search for an island
Function SearchIslandPage(stream)
	Header(stream)

	WriteLine stream, "<h1>Island Search</h1>"
	WriteLine stream, "Search for islands by using various <b>filters</b>. To apply a filter, enter a value in the textbox, blank filters will be ignored. Only results matching all the filter conditions will be shown, selecting no filters will list <b>everything</b>. You can apply any combination of filters, but be warned that some are mutually exclusive. When you are done, click <b>search!</b><br><br>"

	WriteLine stream, "<form name="+Chr$(34)+"islandsearch"+Chr$(34)+" action="+Chr$(34)+"island"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>&nbsp;</th><td>Results</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"res"+Chr$(34)+" value="+Chr$(34)+"100"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"2"+Chr$(34)+"><h2>History</h2> Search old data.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days ago (0 is current)</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"date"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Location</h2>Search by ocean:sector:isle.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Ocean</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"ocean"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Sector</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sector"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Isle</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"isle"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"5"+Chr$(34)+"><h2>Position</h2> Search by Cartesian coordinates.<br>"
	WriteLine stream, "(1:1:1 is origin, right is X, down is Y)</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>X at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"x_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>X at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"x_most"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Y at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"y_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Y at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"y_most"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"4"+Chr$(34)+"><h2>Player</h2>Search by owner's info.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Player ID</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"playerid"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Player name</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"playername"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Match part of name</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"playername_search"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"3"+Chr$(34)+"><h2>Alliance</h2> Seach by owner's alliance membership.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Alliance ID</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"allianceid"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Alliance tag</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"alliancetag"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"5"+Chr$(34)+"><h2>Hunter</h2>Search owners for potential targets.</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days inactive at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Days inactive at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_most"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Points/isles at least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Points/isles at most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_most"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	
	WriteLine stream, "<td rowspan="+Chr$(34)+"6"+Chr$(34)+"><h2>Distance</h2>Search by distance from another isle.<br>"
	WriteLine stream, "(ocean:sector:isle needs to be completed)</td>"
;	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At least</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_least"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>At most</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_most"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>From ocean</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_ocean"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>From sector</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_sector"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>From isle</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_isle"+Chr$(34)+"></td>"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td rowspan="+Chr$(34)+"5"+Chr$(34)+"><h2>Trend</h2> Track important changes.</td>"
	WriteLine stream, "<th>Filter</th><th>Value</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Changed Ruler?</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"checkbox"+Chr$(34)+" name="+Chr$(34)+"colod"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Not Changed Ruler?</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"checkbox"+Chr$(34)+" name="+Chr$(34)+"not_colod"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Changed Alliance?</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"checkbox"+Chr$(34)+" name="+Chr$(34)+"moved"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Not Changed Alliance?</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"checkbox"+Chr$(34)+" name="+Chr$(34)+"not_moved"+Chr$(34)+"></td>"
	
	WriteLine stream, "</table>"
	WriteLine stream, "<br>"
	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Search!"+Chr$(34)+">"
	WriteLine stream, "</form>"

	Footer(stream)
End Function


Function SearchInactivePage(stream)
	Header(stream)

WriteLine stream, "<h1>Inactive Finder</h1>"
WriteLine stream, "<p>This tool is a subset of the <a href="+Chr$(34)+"/search?islands"+Chr$(34)+">Island Search</a>. All fields are optional, and only islands matching all the fields will be returned. Click <b>Search!</b> to get the results.</p>"
WriteLine stream, "<form name="+Chr$(34)+"islandsearch"+Chr$(34)+" action="+Chr$(34)+"island"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"

WriteLine stream, "<hr>"

WriteLine stream, "<p>To find islands by inactivity, enter the <b>minimum</b> number of consecutive days since last score increase.</p>"
WriteLine stream, "<table>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Last active over</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"inactive_least"+Chr$(34)+" value="+Chr$(34)+"20"+Chr$(34)+"> days ago</td>"
WriteLine stream, "</table>"

WriteLine stream, "<hr>"

WriteLine stream, "<p>To find islands in a particular sector (group), enter the ocean and sector numbers.</p>"
WriteLine stream, "<table>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Ocean</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"ocean"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Sector</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sector"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"></td>"
WriteLine stream, "</table>"

WriteLine stream, "<hr>"

WriteLine stream, "<p>To find islands by distance from another island, enter <b>either</b> closer, farther or <b>both</b> distances. Then you <b>must</b> enter the island coordinates.</p>"
WriteLine stream, "<table>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Farther than</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_least"+Chr$(34)+"> NM</td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Closer than</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_most"+Chr$(34)+"> NM</td>"
WriteLine stream, "</td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>to this island</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_ocean"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"> : <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_sector"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"> : <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"distance_isle"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"></td>"
WriteLine stream, "</table>"

WriteLine stream, "<hr>"

WriteLine stream, "<p>To find islands in a particular alliance, enter the ID number <b>or</b> Tag (without brakets). To find unallied islands, enter <b>0</b> in the ID box.</p>"
WriteLine stream, "<table>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Alliance ID</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"allianceid"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Alliance Tag</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"alliancetag"+Chr$(34)+"></td>"
WriteLine stream, "</table>"

WriteLine stream, "<hr>"

WriteLine stream, "<p>To find islands by their development, enter <b>either</b> minimum, maximum or <b>both</b> scores (0 to 1000). This is estimated from the players score and number of islands.</p>"
WriteLine stream, "<table>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Minimum</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_least"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Maximum</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"develop_most"+Chr$(34)+"></td>"
WriteLine stream, "</table>"

WriteLine stream, "<hr>"

WriteLine stream, "<p>Enter the maximum number of results that can be returned.</p>"
WriteLine stream, "<table>"
WriteLine stream, "<tr>"
WriteLine stream, "<td>Results</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"res"+Chr$(34)+" value="+Chr$(34)+"100"+Chr$(34)+"></td>"
WriteLine stream, "</table>"

WriteLine stream, "<hr>"

WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Search!"+Chr$(34)+">"
WriteLine stream, "</form>"

	Footer(stream)
End Function





Function MapAlliancePage(html,v_ocean,v_sector,v_date,a0$,a1$,a2$,a3$,a4$,a5$)

	index = v_date
	If index<0 Then index=0 : If index>last_data Then index=last_data

	aid0=-1
	aid1=-1
	aid2=-1
	aid3=-1
	aid4=-1
	aid5=-1

	Header(html)
	WriteLine html, "<h1>Alliance Map</h1>"
	If v_ocean Then WriteLine html, "<p>Ocean: <b>"+v_ocean+"</b><br>"
	If v_sector Then WriteLine html, "Sector: <b>"+v_sector+"</b><br>"
	WriteLine html, "Date: <b>"+date$(index)+"</b></p>"

	WriteLine html, "<h2>Legend</h2>"
	If a0$<>"" ; red
		WriteLine html, "<span style="+Chr(34)+"color:#FF0000"+Chr(34)+">"+ a0$ +"</span> "
		For p.alliance = Each alliance ;find id from alliance tag
			If Lower$(p\tag$[index]) = Lower$(a0$)
				aid0 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a1$<>"" ; orange
		WriteLine html, "<span style="+Chr(34)+"color:#FF8C00"+Chr(34)+">"+ a1$ +"</span> "
		For p.alliance = Each alliance ;find id from alliance tag
			If Lower$(p\tag$[index]) = Lower$(a1$)
				aid1 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a2$<>"" ; green
		WriteLine html, "<span style="+Chr(34)+"color:#00FF00"+Chr(34)+">"+ a2$ +"</span> "
		For p.alliance = Each alliance ;find id from alliance tag
			If Lower$(p\tag$[index]) = Lower$(a2$)
				aid2 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a3$<>"" ; cyan
		WriteLine html, "<span style="+Chr(34)+"color:#00FFFF"+Chr(34)+">"+ a3$ +"</span> "
		For p.alliance = Each alliance ;find id from alliance tag
			If Lower$(p\tag$[index]) = Lower$(a3$)
				aid3 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a4$<>"" ; blue
		WriteLine html, "<span style="+Chr(34)+"color:#0000FF"+Chr(34)+">"+ a4$ +"</span> "
		For p.alliance = Each alliance ;find id from alliance tag
			If Lower$(p\tag$[index]) = Lower$(a4$)
				aid4 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a5$<>"" ; purple
		WriteLine html, "<span style="+Chr(34)+"color:#FF00FF"+Chr(34)+">"+ a5$ +"</span> "
		For p.alliance = Each alliance ;find id from alliance tag
			If Lower$(p\tag$[index]) = Lower$(a5$)
				aid5 = p\id
				Exit
			EndIf
		Next
	EndIf
	WriteLine html, "<br>"
	
	WriteLine html, "<h2>Map</h2>"
	If v_sector Then ;sector map
		WriteLine html, "<img src="+Chr(34)+"alliancesectormapimage?ocean="+v_ocean+"&amp;sector="+v_sector+"&amp;date="+index+"&amp;a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"map - do not reload"+Chr(34)+" width="+Chr(34)+"200"+Chr(34)+" height="+Chr(34)+"200"+Chr(34)+">"
	Else
		If v_ocean Then ;ocean map
			WriteLine html, "<img src="+Chr(34)+"allianceoceanmapimage?ocean="+v_ocean+"&amp;date="+index+"&amp;a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"map - do not reload"+Chr(34)+" width="+Chr(34)+"500"+Chr(34)+" height="+Chr(34)+"500"+Chr(34)+">"
		Else ;world map
			WriteLine html, "<img src="+Chr(34)+"allianceworldmapimage?date="+index+"&amp;a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"map - do not reload"+Chr(34)+" width="+Chr(34)+"1000"+Chr(34)+" height="+Chr(34)+"1000"+Chr(34)+">"
		EndIf
	EndIf
	Footer(html)
End Function





Function MapPlayerPage(html,v_ocean,v_sector,v_date,a0$,a1$,a2$,a3$,a4$,a5$)

	index = v_date
	If index<0 Then index=0 : If index>last_data Then index=last_data

	aid0=-1
	aid1=-1
	aid2=-1
	aid3=-1
	aid4=-1
	aid5=-1

	Header(html)
	WriteLine html, "<h1>Player Map</h1>"
	If v_ocean Then WriteLine html, "<p>Ocean: <b>"+v_ocean+"</b><br>"
	If v_sector Then WriteLine html, "Sector: <b>"+v_sector+"</b><br>"
	WriteLine html, "Date: <b>"+date$(index)+"</b></p>"

	WriteLine html, "<h2>Legend</h2>"
	If a0$<>"" ; red
		WriteLine html, "<span style="+Chr(34)+"color:#FF0000"+Chr(34)+">"+ a0$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[index]) = Lower$(a0$)
				aid0 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a1$<>"" ; orange
		WriteLine html, "<span style="+Chr(34)+"color:#FF8C00"+Chr(34)+">"+ a1$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[index]) = Lower$(a1$)
				aid1 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a2$<>"" ; green
		WriteLine html, "<span style="+Chr(34)+"color:#00FF00"+Chr(34)+">"+ a2$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[index]) = Lower$(a2$)
				aid2 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a3$<>"" ; cyan
		WriteLine html, "<span style="+Chr(34)+"color:#00FFFF"+Chr(34)+">"+ a3$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[index]) = Lower$(a3$)
				aid3 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a4$<>"" ; blue
		WriteLine html, "<span style="+Chr(34)+"color:#0000FF"+Chr(34)+">"+ a4$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[index]) = Lower$(a4$)
				aid4 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a5$<>"" ; purple
		WriteLine html, "<span style="+Chr(34)+"color:#FF00FF"+Chr(34)+">"+ a5$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[index]) = Lower$(a5$)
				aid5 = p\id
				Exit
			EndIf
		Next
	EndIf
	WriteLine html, "<br>"
	
	WriteLine html, "<h2>Map</h2>"
	If v_sector Then ;sector map
		WriteLine html, "<img src="+Chr(34)+"playersectormapimage?ocean="+v_ocean+"&amp;sector="+v_sector+"&amp;date="+index+"&amp;a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"map - do not reload"+Chr(34)+" width="+Chr(34)+"200"+Chr(34)+" height="+Chr(34)+"200"+Chr(34)+">"
	Else
		If v_ocean Then ;ocean map
			WriteLine html, "<img src="+Chr(34)+"playeroceanmapimage?ocean="+v_ocean+"&amp;date="+index+"&amp;a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"map - do not reload"+Chr(34)+" width="+Chr(34)+"500"+Chr(34)+" height="+Chr(34)+"500"+Chr(34)+">"
		Else ;world map
			WriteLine html, "<img src="+Chr(34)+"playerworldmapimage?date="+index+"&amp;a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"map - do not reload"+Chr(34)+" width="+Chr(34)+"1000"+Chr(34)+" height="+Chr(34)+"1000"+Chr(34)+">"
		EndIf
	EndIf
	Footer(html)
End Function







Function DistanceCalcPage(html,ocean,sector,isle)
	Header(html)
	WriteLine html, "<h1>Distance Calculator</h1>"
	WriteLine html, "<form name="+Chr(34)+"distance"+Chr(34)+" action="+Chr(34)+"distance"+Chr(34)+" method="+Chr(34)+"get"+Chr(34)+">"
	WriteLine html, "Source<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"o1"+Chr(34)+" value="+Chr(34)+ocean+Chr(34)+">"
	WriteLine html, " : <input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"s1"+Chr(34)+" value="+Chr(34)+sector+Chr(34)+">"
	WriteLine html, " : <input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"i1"+Chr(34)+" value="+Chr(34)+isle+Chr(34)+"><br>"
	WriteLine html, "Destination<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"o2"+Chr(34)+">"
	WriteLine html, " : <input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"s2"+Chr(34)+">"
	WriteLine html, " : <input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"i2"+Chr(34)+"><br>"
	WriteLine html, "<input type="+Chr(34)+"submit"+Chr(34)+" value="+Chr(34)+"Calculate!"+Chr(34)+">"
	WriteLine html, "</form>"	
	Footer(html)
End Function



Function MapSearchAlliancePage(stream)
	Header(stream)
WriteLine stream, "<h1>Alliance Map</h1>"
WriteLine stream, "<form name="+Chr$(34)+"graph"+Chr$(34)+" action="+Chr$(34)+"alliancemappage"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
WriteLine stream, "<p>Map where? Enter the <b>ocean</b> below to map only that ocean, or the <b>ocean and sector</b> below to map only that sector. Leave blank to map the whole world!<br>"
WriteLine stream, "Ocean <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"ocean"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"><br>"
WriteLine stream, "Sector <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sector"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"></p>"
WriteLine stream, "<p>As it was <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"date"+Chr$(34)+" value="+Chr$(34)+"0"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"> days ago</p>"
WriteLine stream, "<p>Enter the <b>alliance tag</b> to draw all the islands for that alliance in that colour, or leave blank to omit. Invalid names will be ignored. Click <b>Map!</b> for the results.</p>"
WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
WriteLine stream, "<tr>"
WriteLine stream, "<th>Colour</th><th>Alliance Tag</th>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#FF0000"+Chr$(34)+">Red</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a0"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#FF8C00"+Chr$(34)+">Orange</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a1"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#00FF00"+Chr$(34)+">Green</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a2"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#00FFFF"+Chr$(34)+">Cyan</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a3"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#0000FF"+Chr$(34)+">Blue</td>"

WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a4"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#FF00FF"+Chr$(34)+">Purple</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a5"+Chr$(34)+"></td>"
WriteLine stream, "</table>"
WriteLine stream, "<br>"
WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Map!"+Chr$(34)+">"
WriteLine stream, "</form>"
	Footer(stream)
End Function

Function MapSearchPlayerPage(stream)
	Header(stream)
WriteLine stream, "<h1>Player Map</h1>"
WriteLine stream, "<form name="+Chr$(34)+"graph"+Chr$(34)+" action="+Chr$(34)+"playermappage"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
WriteLine stream, "<p>Map where? Enter the <b>ocean</b> below to map only that ocean, or the <b>ocean and sector</b> below to map only that sector. Leave blank to map the whole world!<br>"
WriteLine stream, "Ocean <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"ocean"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"><br>"
WriteLine stream, "Sector <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sector"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"></p>"
WriteLine stream, "<p>As it was <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"date"+Chr$(34)+" value="+Chr$(34)+"0"+Chr$(34)+" size="+Chr$(34)+"2"+Chr$(34)+"> days ago</p>"
WriteLine stream, "<p>Enter the <b>player name</b> to draw all the islands for that player in that colour, or leave blank to omit. Invalid names will be ignored. Click <b>Map!</b> for the results.</p>"
WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
WriteLine stream, "<tr>"
WriteLine stream, "<th>Colour</th><th>Player Name</th>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#FF0000"+Chr$(34)+">Red</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a0"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#FF8C00"+Chr$(34)+">Orange</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a1"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#00FF00"+Chr$(34)+">Green</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a2"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#00FFFF"+Chr$(34)+">Cyan</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a3"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#0000FF"+Chr$(34)+">Blue</td>"

WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a4"+Chr$(34)+"></td>"
WriteLine stream, "<tr>"
WriteLine stream, "<td style="+Chr$(34)+"color:#FF00FF"+Chr$(34)+">Purple</td>"
WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a5"+Chr$(34)+"></td>"
WriteLine stream, "</table>"
WriteLine stream, "<br>"
WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Map!"+Chr$(34)+">"
WriteLine stream, "</form>"
	Footer(stream)
End Function

Function HistoryAlliancePage(html)
	Header(html)
	WriteLine html, "<h1>Alliance History</h1>"
	WriteLine html, "<a href="+Chr(34)+"search?alliances"+Chr(34)+">Search for an alliance?</a><br><br>"
	WriteLine html, "<h2>Alliance Tag</h2>"
	WriteLine html, "<form name="+Chr(34)+"historytag"+Chr(34)+" action="+Chr(34)+"history"+Chr(34)+" method="+Chr(34)+"get"+Chr(34)+">"
	WriteLine html, "Alliance Tag<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"alliancetag"+Chr(34)+"><br>"
	WriteLine html, "<input type="+Chr(34)+"submit"+Chr(34)+" value="+Chr(34)+"Show!"+Chr(34)+">"
	WriteLine html, "</form>"	
	WriteLine html, "<h2>Alliance ID</h2>"
	WriteLine html, "<form name="+Chr(34)+"historyid"+Chr(34)+" action="+Chr(34)+"history"+Chr(34)+" method="+Chr(34)+"get"+Chr(34)+">"
	WriteLine html, "Alliance ID<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"allianceid"+Chr(34)+"><br>"
	WriteLine html, "<input type="+Chr(34)+"submit"+Chr(34)+" value="+Chr(34)+"Show!"+Chr(34)+">"
	WriteLine html, "</form>"	
	Footer(html)
End Function

Function HistoryPlayerPage(html)
	Header(html)
	WriteLine html, "<h1>Player History</h1>"
	WriteLine html, "<a href="+Chr(34)+"search?players"+Chr(34)+">Search for a player?</a><br><br>"
	WriteLine html, "<h2>Player Name</h2>"
	WriteLine html, "<form name="+Chr(34)+"historyname"+Chr(34)+" action="+Chr(34)+"history"+Chr(34)+" method="+Chr(34)+"get"+Chr(34)+">"
	WriteLine html, "Player Name<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"playername"+Chr(34)+"><br>"
	WriteLine html, "<input type="+Chr(34)+"submit"+Chr(34)+" value="+Chr(34)+"Show!"+Chr(34)+">"
	WriteLine html, "</form>"
	WriteLine html, "<h2>Player ID</h2>"
	WriteLine html, "<form name="+Chr(34)+"historyid"+Chr(34)+" action="+Chr(34)+"history"+Chr(34)+" method="+Chr(34)+"get"+Chr(34)+">"
	WriteLine html, "Player ID<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"playerid"+Chr(34)+"><br>"
	WriteLine html, "<input type="+Chr(34)+"submit"+Chr(34)+" value="+Chr(34)+"Show!"+Chr(34)+">"
	WriteLine html, "</form>"	
	Footer(html)
End Function

Function HistoryIslandPage(html)
	Header(html)
	WriteLine html, "<h1>Island History</h1>"
	WriteLine html, "<a href="+Chr(34)+"search?islands"+Chr(34)+">Search for an island?</a><br><br>"
	WriteLine html, "<h2>Island Location</h2>"
	WriteLine html, "<form name="+Chr(34)+"history"+Chr(34)+" action="+Chr(34)+"history"+Chr(34)+" method="+Chr(34)+"get"+Chr(34)+">"
	WriteLine html, "Ocean:Sector:Isle<br>"
	WriteLine html, "<input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"ocean"+Chr(34)+">"
	WriteLine html, " : <input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"sector"+Chr(34)+">"
	WriteLine html, " : <input type="+Chr(34)+"text"+Chr(34)+" name="+Chr(34)+"isle"+Chr(34)+"><br>"
	WriteLine html, "<input type="+Chr(34)+"submit"+Chr(34)+" value="+Chr(34)+"Show!"+Chr(34)+">"
	WriteLine html, "</form>"
	Footer(html)
End Function






;Function LoginPage(http_stream)
;	Header(http_stream)
;	WriteLine http_stream, "<h1>Cucco's Tools</h1>"
;	WriteLine http_stream, "<form name=" + Chr$(34) + "login" + Chr$(34) + " action=" + Chr$(34) + "login" + Chr$(34) + " method=" + Chr$(34) + "get" + Chr$(34) + ">"
;	WriteLine http_stream, "<table>"
;	WriteLine http_stream, "<tr><td>Username</td><td><input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "u" + Chr$(34) + " size=" + Chr$(34) + "20" + Chr$(34) + "></td>"
;	WriteLine http_stream, "<tr><td>Password</td><td><input type=" + Chr$(34) + "password" + Chr$(34) + " name=" + Chr$(34) + "p" + Chr$(34) + " size=" + Chr$(34) + "20" + Chr$(34) + "></td>"
;	WriteLine http_stream, "<tr><td><a href=" + Chr$(34) + "info" + Chr$(34) + ">Info</a></td><td align=" + Chr$(34) + "right" + Chr$(34) + "><input type=" + Chr$(34) + "submit" + Chr$(34) + " value=" + Chr$(34) + "Login" + Chr$(34) + "></td>"
;	WriteLine http_stream, "</table>"
;	WriteLine http_stream, "</form>"
;	Footer(http_stream)
;End Function

;Function InfoPage(http_stream)
;	Header(http_stream)
;	WriteLine http_stream, "<h1>Info</h1>"
;	WriteLine http_stream, "<p>&copy; 2007-2008 flying_cucco. Thanks to everyone who helped out!</p>"
;	WriteLine http_stream, "<p>CT is a <b>completely free</b> database and 'tools' for <a href=" + Chr$(34) + "http://www.inselkampf.com" + Chr$(34) + ">Inselkampf.com</a> World 2. The site aims to provide more detailed information for players, but will not automate - and is completely separate from - the game.</p>"
;	WriteLine http_stream, "<p>Principle features include:<ul>"
;	WriteLine http_stream, "<li>Advanced search engine</li>"
;	WriteLine http_stream, "<li>Detailed history</li>"
;	WriteLine http_stream, "<li>Charts and maps</li>"
;	WriteLine http_stream, "<li>Isle management tools</li>"
;	WriteLine http_stream, "<li>Report database</li>"
;	WriteLine http_stream, "</ul></p>"
;	WriteLine http_stream, "<h2>Registration</h2>"
;	WriteLine http_stream, "<p>To register, send a message to <a href=" + Chr$(34) + "http://h728.serverid.net/inselkampf/my/messages/new?recipient=flying_cucco" + Chr$(34) + ">flying_cucco</a> in game. Make the subject " + Chr$(34) + "<b>Register</b>" + Chr$(34) + " and specify a password in the message body. You must be a IKC player, and have been in the game for at least 24 hours before you can register. If you change accounts, you must re-register with the new account.</p>"
;	WriteLine http_stream, "<h2>Username</h2>"
;	WriteLine http_stream, "<p>Your username is the same as your IK player name, but is <b>case sensitive</b>. If you change your IK player name, your CT username will change too, within 24 hours</p>"
;	WriteLine http_stream, "<h2>Password</h2>"
;	WriteLine http_stream, "<p>Your password should <b>not</b> be the same as your IK password. Please choose hard passwords! Do not share your password with anyone else, or you may be banned.</p>"
;	WriteLine http_stream, "<h2>Contact</h2>"
;	WriteLine http_stream, "<p>Please mail <a href=" + Chr$(34) + "http://h728.serverid.net/inselkampf/my/messages/new?recipient=flying_cucco" + Chr$(34) + ">flying_cucco</a> with any feedback, or if you need any help with the tools.</p>"
;	Footer(http_stream)
;End Function

;Function AddUserPage(stream)
;	Header(stream)
;	WriteLine stream, "<h1>Add User</h1>"
;	WriteLine stream, "<form name="+Chr$(34)+"adduser"+Chr$(34)+" action="+Chr$(34)+"user"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
;	WriteLine stream, "Username <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"u"+Chr$(34)+"><br>"
;	WriteLine stream, "Password <input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"p"+Chr$(34)+"><br>"
;	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Add"+Chr$(34)+">"
;	WriteLine stream, "</form>"
;	Footer(stream)
;End Function


Function BuildCalcPage(stream)
	Header(stream)

	WriteLine stream, "<h1>Schedule Planner</h1>"
	WriteLine stream, "Calculate the build costs and surplus of an island's daily XXL schedule. When you are done, hit <b>Calculate!</b>, use back to modify these values."
	WriteLine stream, "<form name="+Chr$(34)+"scheduleplanner"+Chr$(34)+" action="+Chr$(34)+"build"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	
	WriteLine stream, "<tr>"
	WriteLine stream, "<td colspan="+Chr$(34)+"2"+Chr$(34)+"><h2>Resource Generation</h2> The levels of the resource collecting buildings on your island.</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Building</th><th>Level</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Gold Mine</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"gold"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Stone Quarry</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"stone"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Lumber Mill</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"lumber"+Chr$(34)+"></td>"

	WriteLine stream, "<tr>"
	WriteLine stream, "<td colspan="+Chr$(34)+"2"+Chr$(34)+"><h2>Unit Production</h2> The daily schedule for unit production on the same island.</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Unit</th><th>Number</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Small Warships</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sws"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Small Merchant Ships</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sms"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Warships</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"ws"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Merchant Ships</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"ms"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Stonethrowers</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"st"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Spear Fighters</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"sf"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Archers</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Catapults</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"c"+Chr$(34)+"></td>"
	
	WriteLine stream, "</table>"
	WriteLine stream, "<br>"
	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Calculate!"+Chr$(34)+">"
	WriteLine stream, "</form>"
	
	Footer(stream)
End Function



Function GraphSearchAlliancePage(stream)
	Header(stream)
	WriteLine stream, "<h1>Alliance Graph</h1>"
	WriteLine stream, "Chart and compare scores for alliances. Enter the <b>alliance tag</b> (without brackets) to draw a line in that colour for that alliance, or leave blank to omit. Invalid tags will be ignored. Click <b>graph!</b> for the results.<br><br>"
	WriteLine stream, "<form name="+Chr$(34)+"graph"+Chr$(34)+" action="+Chr$(34)+"alliancegraphpage"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Colour</th><th>Alliance Tag</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#FF0000"+Chr$(34)+">Red</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a0"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#FF8C00"+Chr$(34)+">Orange</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a1"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#00FF00"+Chr$(34)+">Green</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a2"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#00FFFF"+Chr$(34)+">Cyan</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a3"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#0000FF"+Chr$(34)+">Blue</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a4"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#FF00FF"+Chr$(34)+">Purple</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a5"+Chr$(34)+"></td>"
	WriteLine stream, "</table>"
	WriteLine stream, "<br>"
	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Graph!"+Chr$(34)+">"
	WriteLine stream, "</form>"
	Footer(stream)
End Function


Function GraphSearchPlayerPage(stream)
	Header(stream)
	WriteLine stream, "<h1>Player Graph</h1>"
	WriteLine stream, "Chart and compare scores for players. Enter the <b>player name</b> to draw a line in that colour for that player, or leave blank to omit. Invalid names will be ignored. Click <b>graph!</b> for the results.<br><br>"
	WriteLine stream, "<form name="+Chr$(34)+"graph"+Chr$(34)+" action="+Chr$(34)+"playergraphpage"+Chr$(34)+" method="+Chr$(34)+"get"+Chr$(34)+">"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Colour</th><th>Player Name</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#FF0000"+Chr$(34)+">Red</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a0"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#FF8C00"+Chr$(34)+">Orange</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a1"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#00FF00"+Chr$(34)+">Green</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a2"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#00FFFF"+Chr$(34)+">Cyan</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a3"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#0000FF"+Chr$(34)+">Blue</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a4"+Chr$(34)+"></td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td style="+Chr$(34)+"color:#FF00FF"+Chr$(34)+">Purple</td>"
	WriteLine stream, "<td><input type="+Chr$(34)+"text"+Chr$(34)+" name="+Chr$(34)+"a5"+Chr$(34)+"></td>"
	WriteLine stream, "</table>"
	WriteLine stream, "<br>"
	WriteLine stream, "<input type="+Chr$(34)+"submit"+Chr$(34)+" value="+Chr$(34)+"Graph!"+Chr$(34)+">"
	WriteLine stream, "</form>"
	Footer(stream)
End Function


Function GraphAlliancePage(html,a0$,a1$,a2$,a3$,a4$,a5$)
	aid0=-1
	aid1=-1
	aid2=-1
	aid3=-1
	aid4=-1
	aid5=-1

	Header(html)
	WriteLine html, "<h1>Alliance Graph</h1>"

	WriteLine html, "<h2>Legend</h2>"
	If a0$<>"" ; red
		WriteLine html, "<span style="+Chr(34)+"color:#FF0000"+Chr(34)+">"+ a0$ +"</span> "
		For a.alliance = Each alliance ;find id from alliance tag
			If Lower$(a\tag$[0]) = Lower$(a0$)
				aid0 = a\id
				Exit
			EndIf
		Next
	EndIf
	If a1$<>"" ; orange
		WriteLine html, "<span style="+Chr(34)+"color:#FF8C00"+Chr(34)+">"+ a1$ +"</span> "
		For a.alliance = Each alliance ;find id from alliance tag
			If Lower$(a\tag$[0]) = Lower$(a1$)
				aid1 = a\id
				Exit
			EndIf
		Next
	EndIf
	If a2$<>"" ; green
		WriteLine html, "<span style="+Chr(34)+"color:#00FF00"+Chr(34)+">"+ a2$ +"</span> "
		For a.alliance = Each alliance ;find id from alliance tag
			If Lower$(a\tag$[0]) = Lower$(a2$)
				aid2 = a\id
				Exit
			EndIf
		Next
	EndIf
	If a3$<>"" ; cyan
		WriteLine html, "<span style="+Chr(34)+"color:#00FFFF"+Chr(34)+">"+ a3$ +"</span> "
		For a.alliance = Each alliance ;find id from alliance tag
			If Lower$(a\tag$[0]) = Lower$(a3$)
				aid3 = a\id
				Exit
			EndIf
		Next
	EndIf
	If a4$<>"" ; blue
		WriteLine html, "<span style="+Chr(34)+"color:#0000FF"+Chr(34)+">"+ a4$ +"</span> "
		For a.alliance = Each alliance ;find id from alliance tag
			If Lower$(a\tag$[0]) = Lower$(a4$)
				aid4 = a\id
				Exit
			EndIf
		Next
	EndIf
	If a5$<>"" ; purple
		WriteLine html, "<span style="+Chr(34)+"color:#FF00FF"+Chr(34)+">"+ a5$ +"</span> "
		For a.alliance = Each alliance ;find id from alliance tag
			If Lower$(a\tag$[0]) = Lower$(a5$)
				aid5 = a\id
				Exit
			EndIf
		Next
	EndIf
	WriteLine html, "<br>"
	
	WriteLine html, "<h2>Graph</h2>"
	WriteLine html, "<img src="+Chr(34)+"alliancegraphimage?a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"graph - do not reload"+Chr(34)+">"
	Footer(html)
End Function

Function GraphPlayerPage(html,a0$,a1$,a2$,a3$,a4$,a5$)
	aid0=-1
	aid1=-1
	aid2=-1
	aid3=-1
	aid4=-1
	aid5=-1

	Header(html)
	WriteLine html, "<h1>Player Graph</h1>"

	WriteLine html, "<h2>Legend</h2>"
	If a0$<>"" ; red
		WriteLine html, "<span style="+Chr(34)+"color:#FF0000"+Chr(34)+">"+ a0$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[0]) = Lower$(a0$)
				aid0 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a1$<>"" ; orange
		WriteLine html, "<span style="+Chr(34)+"color:#FF8C00"+Chr(34)+">"+ a1$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[0]) = Lower$(a1$)
				aid1 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a2$<>"" ; green
		WriteLine html, "<span style="+Chr(34)+"color:#00FF00"+Chr(34)+">"+ a2$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[0]) = Lower$(a2$)
				aid2 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a3$<>"" ; cyan
		WriteLine html, "<span style="+Chr(34)+"color:#00FFFF"+Chr(34)+">"+ a3$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[0]) = Lower$(a3$)
				aid3 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a4$<>"" ; blue
		WriteLine html, "<span style="+Chr(34)+"color:#0000FF"+Chr(34)+">"+ a4$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[0]) = Lower$(a4$)
				aid4 = p\id
				Exit
			EndIf
		Next
	EndIf
	If a5$<>"" ; purple
		WriteLine html, "<span style="+Chr(34)+"color:#FF00FF"+Chr(34)+">"+ a5$ +"</span> "
		For p.player = Each player ;find id from player tag
			If Lower$(p\name$[0]) = Lower$(a5$)
				aid5 = p\id
				Exit
			EndIf
		Next
	EndIf
	WriteLine html, "<br>"
	
	WriteLine html, "<h2>Graph</h2>"
	WriteLine html, "<img src="+Chr(34)+"playergraphimage?a0="+aid0+"&amp;a1="+aid1+"&amp;a2="+aid2+"&amp;a3="+aid3+"&amp;a4="+aid4+"&amp;a5="+aid5+Chr(34)+" alt="+Chr(34)+"graph - do not reload"+Chr(34)+">"
	Footer(html)
End Function



;Function SpyPage(http_stream)
;	Header(http_stream)
;	WriteLine http_stream, "<h1>Reports</h1>
;	
;	WriteLine http_stream, "<h2>Add Report</h2>"
;	WriteLine http_stream, "<p>Add a report to the database (copy and paste). Reports are only visible to you, and members of your alliance.</p>"
;	WriteLine http_stream, "<form name=" + Chr$(34) + "input" + Chr$(34) + " action=" + Chr$(34) + "newspy" + Chr$(34) + " method=" + Chr$(34) + "get" + Chr$(34) + ">"
;	WriteLine http_stream, "<p>Share report with other alliances? <input type=" + Chr$(34) + "checkbox" + Chr$(34) + " name=" + Chr$(34) + "p" + Chr$(34) + " value=" + Chr$(34) + "public" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<p>Island<br><input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "o" + Chr$(34) + " size=" + Chr$(34) + "2" + Chr$(34) + "> : <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "s" + Chr$(34) + " size=" + Chr$(34) + "2" + Chr$(34) + "> : <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "i" + Chr$(34) + " size=" + Chr$(34) + "2" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<p>Report<br><textarea name=" + Chr$(34) + "r" + Chr$(34) + " rows=" + Chr$(34) + "5" + Chr$(34) + " cols=" + Chr$(34) + "50" + Chr$(34) + "></textarea></p>"
;	WriteLine http_stream, "<input type=" + Chr$(34) + "submit" + Chr$(34) + " value=" + Chr$(34) + "Add Report" + Chr$(34) + "></form>"
;
;	WriteLine http_stream, "<hr>"
;	
;	WriteLine http_stream, "<h2>Search Reports</h2>"
;	WriteLine http_stream, "<p>Show existing reports. You can apply filters to narrow the results. Or you can search <a href="+Chr(34)+"search?alliances"+Chr(34)+">Alliances</a>, <a href="+Chr(34)+"search?players"+Chr(34)+">Players</a> and <a href="+Chr(34)+"search?islands"+Chr(34)+">Islands</a>.</p>"
;	WriteLine http_stream, "<form name=" + Chr$(34) + "input" + Chr$(34) + " action=" + Chr$(34) + "findspy" + Chr$(34) + " method=" + Chr$(34) + "get" + Chr$(34) + ">"
;	WriteLine http_stream, "<p>Coordinates <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "o" + Chr$(34) + " size=" + Chr$(34) + "2" + Chr$(34) + "> : <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "s" + Chr$(34) + " size=" + Chr$(34) + "2" + Chr$(34) + "> : <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "i" + Chr$(34) + " size=" + Chr$(34) + "2" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<p>Alliance Tag <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "t" + Chr$(34) + " size=" + Chr$(34) + "30" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<p>Alliance ID <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "a" + Chr$(34) + " size=" + Chr$(34) + "3" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<p>Player Name <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "n" + Chr$(34) + " size=" + Chr$(34) + "30" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<p>Player ID <input type=" + Chr$(34) + "text" + Chr$(34) + " name=" + Chr$(34) + "p" + Chr$(34) + " size=" + Chr$(34) + "3" + Chr$(34) + "></p>"
;	WriteLine http_stream, "<input type=" + Chr$(34) + "submit" + Chr$(34) + " value=" + Chr$(34) + "Show Reports" + Chr$(34) + "></form>"
;
;	Footer(http_stream)
;End Function