;Function Login(stream,username$,pass$)
;
;	;check login against users
;	For u.user=Each user
;		If u\username$ = username$ Then
;			If u\pass$ = pass$ Then
;				
;				;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				;Login Successful
;				;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				u\cookie$=username$+Rand(-2147483648)+Rand(-2147483648)
;
;				user$=username$
;				
;				IndexPage(stream,u\cookie$)
;
;				;WriteLog ("("+username$+") logged in, cookie: "+u\cookie$)
;				Return True
;			EndIf
;		EndIf
;	Next
;
;	;failed
;	ErrorPage(stream,"Username or password incorrect.")
;	;WriteLog ("("+username$+") login failed, password tried: "+pass$)
;	Return False
;	
;End Function



Function AllianceSearch(stream,c_date,c_allianceid,c_alliancetag,c_alliancetag_search,c_score,c_score_least,c_score_most,c_rank,c_rank_least,c_rank_most,c_members,c_members_least,c_members_most,c_islands,c_islands_least,c_islands_most,c_inactive_least,c_inactive_most,c_develop_least,c_develop_most,v_date,v_allianceid,v_alliancetag$,v_alliancetag_search$,v_score,v_score_least,v_score_most,v_rank,v_rank_least,v_rank_most,v_members,v_members_least,v_members_most,v_islands,v_islands_least,v_islands_most,v_inactive_least,v_inactive_most,v_develop_least,v_develop_most,c_res,v_res)
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Search Alliances
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	index = 0
	If c_date Then index = v_date ; for searching in history
	If index<0 Then index=0
	If index>last_data Then index=last_data

	Header(stream)
	WriteLine stream, "<h1>Alliance Search Results</h1>"
	WriteLine stream, "<h2>Parameters</h2>"
	
	WriteLine stream, "Day <b>"+index+"</b><br>Date <b>"+date$(index)+"</b><br>"
	If index >0 Then WriteLine stream, "<p style="+Chr(34)+"color:red"+Chr(34)+">This information is old. Use <b>Day 0</b> for the latest.</p>"
	
	If c_allianceid Then WriteLine stream, "Alliance ID <b>"+v_allianceid +"</b><br>"
	If c_alliancetag Then WriteLine stream, "Alliance tag <b>"+v_alliancetag$+"</b><br>"
	If c_alliancetag_search Then WriteLine stream, "Alliance tag contains <b>"+v_alliancetag_search$+"</b><br>"
	If c_score Then WriteLine stream, "Score = <b>"+v_score+"</b><br>"
	If c_score_least Then WriteLine stream, "Score >= <b>"+v_score_least+"</b><br>"
	If c_score_most Then WriteLine stream, "Score <= <b>"+v_score_most+"</b><br>"
	If c_rank Then WriteLine stream, "Rank = <b>"+v_rank+"</b><br>"
	If c_rank_least Then WriteLine stream, "Rank >= <b>"+v_rank_least+"</b><br>"
	If c_rank_most Then WriteLine stream, "Rank <= <b>"+v_rank_most+"</b><br>"
	If c_members Then WriteLine stream, "Members = <b>"+v_members+"</b><br>"
	If c_members_least Then WriteLine stream, "Members >= <b>"+v_members_least+"</b><br>"
	If c_members_most Then WriteLine stream, "Members <= <b>"+v_members_most+"</b><br>"
	If c_islands Then WriteLine stream, "Islands = <b>"+v_islands+"</b><br>"
	If c_islands_least Then WriteLine stream, "Islands >= <b>"+v_islands_least+"</b><br>"
	If c_islands_most Then WriteLine stream, "Islands <= <b>"+v_islands_most+"</b><br>"
	If c_inactive_least Then WriteLine stream, "Last active >= <b>"+v_inactive_least+"</b><br>"
	If c_inactive_most Then WriteLine stream, "Last active <= <b>"+v_inactive_most+"</b><br>"
	If c_develop_least Then WriteLine stream, "Points/player >= <b>"+v_develop_least+"</b><br>"
	If c_develop_most Then WriteLine stream, "Points/player <= <b>"+v_develop_most+"</b><br>"


	WriteLine stream, "<h2>Results</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
	WriteLine stream, "<tr>"
;	WriteLine stream, "<th>Day</th>"
;	WriteLine stream, "<th>Date</th>"
	WriteLine stream, "<th>Alliance ID</th>"
	WriteLine stream, "<th>Alliance Tag</th>"
	WriteLine stream, "<th>Score</th>"
	WriteLine stream, "<th>Rank</th>"
	WriteLine stream, "<th>Members</th>"
	WriteLine stream, "<th>Islands</th>"
	WriteLine stream, "<th>% Map</th>"
	WriteLine stream, "<th>Points/Players</th>"
	WriteLine stream, "<th>Inactive</th>"
;	WriteLine stream, "<th>Reports</th>"
	WriteLine stream, "<th>More Info</th>"


	For a.alliance = Each alliance ; loop players
	
		show = True ; mark alliance as matching parameters and can be shown	
	
		If a\members[index] > 0 ;points-per-member
			ppp = (a\score[index] / a\members[index])
		Else
			ppp = 0
		EndIf
	
		;VALIDATE PARAMS
		If c_allianceid And v_allianceid <> a\id Then show = False
		If c_alliancetag And v_alliancetag$ <> Lower$(a\tag$[index]) Then show = False
		If c_alliancetag_search And Instr(Lower$(a\tag$[index]),v_alliancetag_search)=0 Then show = False
		If c_score And v_score <> a\score[index] Then show = False
		If c_score_least And v_score_least > a\score[index] Then show = False
		If c_score_most And v_score_most < a\score[index] Then show = False
		If c_rank And v_rank <> a\rank[index] Then show = False
		If c_rank_least And v_rank_least > a\rank[index] Then show = False
		If c_rank_most And v_rank_most < a\rank[index] Then show = False
		If c_members And v_members <> a\members[index] Then show = False
		If c_members_least And v_members_least > a\members[index] Then show = False
		If c_members_most And v_members_most < a\members[index] Then show = False
		If c_islands And v_islands <> a\islands[index] Then show = False
		If c_islands_least And v_islands_least > a\islands[index] Then show = False
		If c_islands_most And v_islands_most < a\islands[index] Then show = False
		If c_inactive_least And v_inactive_least > a\inactive[index] Then show = False
		If c_inactive_most And v_inactive_most < a\inactive[index] Then show = False
		If c_develop_least And v_develop_least > ppp Then show = False
		If c_develop_most And v_develop_most < ppp Then show = False
		
		If show ;validated, show alliance
		
			If rows=TABLE_ROWS Then
				WriteLine stream, "</table>"
				WriteLine stream, "<br><br>"
				WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
				WriteLine stream, "<tr>"
;				WriteLine stream, "<th>Day</th>"
;				WriteLine stream, "<th>Date</th>"
				WriteLine stream, "<th>Alliance ID</th>"
				WriteLine stream, "<th>Alliance Tag</th>"
				WriteLine stream, "<th>Score</th>"
				WriteLine stream, "<th>Rank</th>"
				WriteLine stream, "<th>Members</th>"
				WriteLine stream, "<th>Islands</th>"
				WriteLine stream, "<th>% Map</th>"
				WriteLine stream, "<th>Points/Players</th>"
				WriteLine stream, "<th>Inactive</th>"
;				WriteLine stream, "<th>Reports</th>"
				WriteLine stream, "<th>More Info</th>"
				rows=0
			EndIf
			rows=rows+1
					
			WriteLine stream, "<tr>"
;			WriteLine stream, "<td>"+index+"</td>"
;			WriteLine stream, "<td>"+date$(index)+"</td>"
			WriteLine stream, "<td>"+a\id+"</td>"
			
;			If a\tag$[index]="" Then ;alliance disbanded / not formed yet
;				WriteLine stream, "<td>---</td>"
;			Else
				WriteLine stream, "<td>"+a\tag$[index]+"</td>"
;			EndIf		
			
			delta=0
			If index<last_data Then delta = a\score[index]-a\score[index+1]
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, a\score[index]+" ("+delta+")</td>"

			delta=0
			If index<last_data Then delta = a\rank[index]-a\rank[index+1]
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, a\rank[index]+" ("+delta+")</td>"

			delta=0
			If index<last_data Then delta = a\members[index]-a\members[index+1]
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, a\members[index]+" ("+delta+")</td>"
			
			delta=0
			If index<last_data Then delta = a\Islands[index]-a\Islands[index+1]
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, a\Islands[index]+" ("+delta+")</td>"
			
			WriteLine stream, "<td>"+(a\islands[index]*100.0/island_count)+"</td>"
			WriteLine stream, "<td>"+ppp+"</td>"
			
			If a\inactive[index]>=40
				WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCFF"+Chr(34)+">"
			ElseIf a\inactive[index]>=20
				WriteLine stream, "<td bgcolor="+Chr(34)+"#FFFFCC"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, a\inactive[index]+"</td>"
			
			
			
			
;			;spy reports count
;			spycount = 0
;			;get user info (move pointer)
;			For u.user = Each user
;				If u\username$ = user$ Then
;					Exit
;				EndIf
;			Next			
;			For s.spy = Each spy
;				; get owner of report (move pointer)
;				submit_player$="" : submit_alliance = 0
;				For p.user = Each user
;					If p\id = s\submit Then
;						submit_player$ = p\username$
;						submit_alliance = p\allianceid
;						Exit
;					EndIf
;				Next
;				;check authorisation to see report
;				auth = False
;				;owner
;				If u\id = s\submit Then
;					auth = True
;				;same alliance as owner
;				ElseIf u\allianceid <> 0 Then
;					If u\allianceid = submit_alliance Then
;						auth=True
;					EndIf
;				EndIf
;				;is public
;				If s\public = True Then auth = True
;			
;				If auth = True Then
;					If s\allianceid = a\id Then spycount = spycount + 1
;				EndIf
;			Next
;			If spycount = 0 Then
;				WriteLine stream, "<td>&nbsp;</td>"
;			Else
;				WriteLine stream, "<td><a href="+Chr(34)+"findspy?a="+ a\id +Chr(34)+">"+spycount+" reports</a></td>"
;			EndIf
			
			
			
			
			WriteLine stream, "<td>"			
			WriteLine stream, "<a href="+Chr(34)+"history?allianceid="+ a\id +Chr(34)+">History</a> "
			WriteLine stream, "<a href="+Chr(34)+"alliancegraphpage?a0="+ a\tag[0] +Chr(34)+">Graph</a> "
			WriteLine stream, "<a href="+Chr(34)+"player?date="+index+"&amp;allianceid="+ a\id +Chr(34)+">Members</a> "
			WriteLine stream, "<a href="+Chr(34)+"island?date="+index+"&amp;allianceid="+ a\id +Chr(34)+">Islands</a> "
			WriteLine stream, "<a href="+Chr(34)+"alliancemappage?ocean=&sector=&date="+index+"&a0="+a\tag$[index]+Chr(34)+">Map</a> "
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/alliances/show/"+ a\id +Chr(34)+">Profile</a>"
			WriteLine stream, "</td>"
		
			;count results
			results=results+1
			;cap results
			If c_res Then
				If results=v_res Then Exit
			EndIf
		
		EndIf
	Next
	
	
	WriteLine stream, "</table>"
	WriteLine stream, "<p>Results <b>"+results+"</b></p>"
	
	Footer(stream)
			
End Function



Function PlayerSearch(stream,c_date,c_playerid,c_playername,c_playername_search,c_score,c_score_least,c_score_most,c_rank,c_rank_least,c_rank_most,c_allianceid,c_alliancetag,c_islands,c_islands_least,c_islands_most,c_inactive_least,c_inactive_most,c_develop_least,c_develop_most,v_date,v_playerid,v_playername$,v_playername_search$,v_score,v_score_least,v_score_most,v_rank,v_rank_least,v_rank_most,v_allianceid,v_alliancetag$,v_islands,v_islands_least,v_islands_most,v_inactive_least,v_inactive_most,v_develop_least,v_develop_most,c_res,v_res)
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Search Players
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	index = 0
	If c_date Then index = v_date ; for searching in history
	If index<0 Then index=0
	If index>last_data Then index=last_data

	Header(stream)
	WriteLine stream, "<h1>Player Search Results</h1>"
	WriteLine stream, "<h2>Parameters</h2>"
	
	WriteLine stream, "Day <b>"+index+"</b><br>Date <b>"+date$(index)+"</b><br>"
	If index >0 Then WriteLine stream, "<p style="+Chr(34)+"color:red"+Chr(34)+">This information is old. Use <b>Day 0</b> for the latest.</p>"
	
	If c_playerid Then WriteLine stream, "Player ID <b>"+v_playerid +"</b><br>"
	If c_playername Then WriteLine stream, "Player name <b>"+v_playername$ +"</b><br>"
	If c_playername_search Then WriteLine stream, "Player name contains <b>"+v_playername_search$ +"</b><br>"
	If c_score Then WriteLine stream, "Score = <b>"+v_score +"</b><br>"
	If c_score_least Then WriteLine stream, "Score >= <b>"+v_score_least+"</b><br>"
	If c_score_most Then WriteLine stream, "Score <= <b>"+v_score_most+"</b><br>"
	If c_rank Then WriteLine stream, "Rank = <b>"+v_rank+"</b><br>"
	If c_rank_least Then WriteLine stream, "Rank >= <b>"+v_rank_least+"</b><br>"
	If c_rank_most Then WriteLine stream, "Rank <= <b>"+v_rank_most+"</b><br>"
	If c_allianceid Then WriteLine stream, "Alliance ID <b>"+v_allianceid+"</b><br>"
	If c_alliancetag Then WriteLine stream, "Alliance tag <b>"+v_alliancetag$+"</b><br>"
	If c_islands Then WriteLine stream, "Islands = <b>"+v_islands+"</b><br>"
	If c_islands_least Then WriteLine stream, "Islands >= <b>"+v_islands_least+"</b><br>"
	If c_islands_most Then WriteLine stream, "Islands <= <b>"+v_islands_most+"</b><br>"
	If c_inactive_least Then WriteLine stream, "Last active >= <b>"+v_inactive_least+"</b><br>"
	If c_inactive_most Then WriteLine stream, "Last active <= <b>"+v_inactive_most+"</b><br>"
	If c_develop_least Then WriteLine stream, "Points/isles >= <b>"+v_develop_least+"</b><br>"
	If c_develop_most Then WriteLine stream, "Points/isles <= <b>"+v_develop_most+"</b><br>"

	
	WriteLine stream, "<h2>Results</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
	WriteLine stream, "<tr>"
;	WriteLine stream, "<th>Day</th>"
;	WriteLine stream, "<th>Date</th>"
	WriteLine stream, "<th>Player ID</th>"
	WriteLine stream, "<th>Player Name</th>"
	WriteLine stream, "<th>Score</th>"
	WriteLine stream, "<th>Rank</th>"
	WriteLine stream, "<th>Alliance ID</th>"
	WriteLine stream, "<th>Alliance Tag</th>"
	WriteLine stream, "<th>Islands</th>"
	WriteLine stream, "<th>Points/Isles</th>"
	WriteLine stream, "<th>Inactive</th>"
;	WriteLine stream, "<th>Reports</th>"
	WriteLine stream, "<th>More Info</th>"


	For p.player = Each player ; loop players

		show = True ; mark player as matching parameters and can be shown	
	
		If p\islands[index] > 0 ;points-per-isle
			ppi = (p\score[index] / p\islands[index])
		Else
			ppi = 0
		EndIf
	
		;VALIDATE PARAMS
		If c_playerid And p\id <> v_playerid Then show = False
		If c_playername And Lower$(p\name$[index]) <> v_playername$ Then show = False
		If c_playername_search And Instr(Lower$(p\name$[index]),v_playername_search$) = 0 Then show = False
		If c_score And p\score[index] <> v_score Then show = False
		If c_score_least And p\score[index] < v_score_least Then show = False
		If c_score_most And p\score[index] > v_score_most Then show = False
		If c_rank And p\rank[index] <> v_rank Then show = False
		If c_rank_least And p\rank[index] < v_rank_least Then show = False
		If c_rank_most And p\rank[index] > v_rank_most Then show = False
		If c_allianceid And p\allianceid[index] <> v_allianceid Then show = False
		If c_alliancetag And Lower$(p\alliancetag$[index]) <> v_alliancetag$ Then show = False
		If c_islands And p\islands[index] <> v_islands Then show = False
		If c_islands_least And p\islands[index] < v_islands_least Then show = False
		If c_islands_most And p\islands[index] > v_islands_most Then show = False
		If c_inactive_least And p\inactive[index] < v_inactive_least Then show = False
		If c_inactive_most And p\inactive[index] > v_inactive_most Then show = False
		If c_develop_least And ppi < v_develop_least Then show = False
		If c_develop_most And ppi > v_develop_most Then show = False
		
		If show ; validated, show player
		
			If rows=TABLE_ROWS Then
				WriteLine stream, "</table>"
				WriteLine stream, "<br><br>"
				WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
				WriteLine stream, "<tr>"
;				WriteLine stream, "<th>Day</th>"
;				WriteLine stream, "<th>Date</th>"
				WriteLine stream, "<th>Player ID</th>"
				WriteLine stream, "<th>Player Name</th>"
				WriteLine stream, "<th>Score</th>"
				WriteLine stream, "<th>Rank</th>"
				WriteLine stream, "<th>Alliance ID</th>"
				WriteLine stream, "<th>Alliance Tag</th>"
				WriteLine stream, "<th>Islands</th>"
				WriteLine stream, "<th>Points/Isles</th>"
				WriteLine stream, "<th>Inactive</th>"
;				WriteLine stream, "<th>Reports</th>"
				WriteLine stream, "<th>More Info</th>"
				rows=0
			EndIf
			rows=rows+1
		
			WriteLine stream, "<tr>"
;			WriteLine stream, "<td>"+index+"</td>"
;			WriteLine stream, "<td>"+date$(index)+"</td>"
			WriteLine stream, "<td>"+p\id+"</td>"
			WriteLine stream, "<td>"+p\name$[index]+"</td>"
			
			delta=0
			If index<last_data Then delta = p\score[index]-p\score[index+1]	
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, p\score[index]+" ("+delta+")</td>"
			
			delta=0
			If index<last_data Then delta = p\rank[index]-p\rank[index+1]	
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, p\rank[index]+" ("+delta+")</td>"
			
			WriteLine stream, "<td>"+p\AllianceID[index]+"</td>"
			WriteLine stream, "<td>"+p\AllianceTag$[index]+"&nbsp;</td>"
			
			delta=0
			If index<last_data Then delta = p\Islands[index]-p\Islands[index+1]	
			If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
			If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
			If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
			WriteLine stream, p\Islands[index]+" ("+delta+")</td>"
			
			WriteLine stream, "<td>"+ppi+"</td>" 
			
			If p\inactive[index]>=40
				WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCFF"+Chr(34)+">"
			ElseIf p\inactive[index]>=20
				WriteLine stream, "<td bgcolor="+Chr(34)+"#FFFFCC"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, p\inactive[index]+"</td>"
			
;			;spy reports count
;			spycount = 0
;			;get user info (move pointer)
;			For u.user = Each user
;				If u\username$ = user$ Then
;					Exit
;				EndIf
;			Next			
;			For s.spy = Each spy
;				submit_player$="" : submit_alliance = 0
;				; get owner of report (move pointer)
;				For up.user = Each user
;					If up\id = s\submit Then
;						submit_player$ = up\username$
;						submit_alliance = up\allianceid
;						Exit
;					EndIf
;				Next
;				
;				;check authorisation to see report
;				auth = False
;				;owner
;				If u\id = s\submit Then
;					auth = True
;				;same alliance as owner
;				ElseIf u\allianceid <> 0 Then
;					If u\allianceid = submit_alliance Then
;						auth=True
;					EndIf
;				EndIf
;				;is public
;				If s\public = True Then auth = True
;			
;				If auth = True Then
;					If s\rulerid = p\id Then spycount = spycount + 1
;				EndIf
;			Next
;			If spycount = 0 Then
;				WriteLine stream, "<td>&nbsp;</td>"
;			Else
;				WriteLine stream, "<td><a href="+Chr(34)+"findspy?p="+ p\id +Chr(34)+">"+spycount+" reports</a></td>"
;			EndIf
			
			
			
			WriteLine stream, "<td>"			
			WriteLine stream, "<a href="+Chr(34)+"history?playerid="+ p\id +Chr(34)+">History</a> "
			WriteLine stream, "<a href="+Chr(34)+"playergraphpage?a0="+ p\name[0] +Chr(34)+">Graph</a> "
			WriteLine stream, "<a href="+Chr(34)+"history?allianceid="+ p\allianceid[index] +Chr(34)+">Alliance</a> "
			WriteLine stream, "<a href="+Chr(34)+"island?check_date=&amp;date="+index+"&amp;check_playerid=&amp;playerid="+ p\id +Chr(34)+">Islands</a> "
			WriteLine stream, "<a href="+Chr(34)+"playermappage?ocean=&sector=&date="+index+"&a0="+p\name$[index]+Chr(34)+">Map</a> "
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/players/"+ p\name[0] +Chr(34)+">Profile</a>"
;			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/my/messages/new?recipient="+ p\name[0] +Chr(34)+">Mail</a>"
			WriteLine stream, "</td>"

		
			;count results
			results=results+1
			;cap results
			If c_res Then
				If results=v_res Then Exit
			EndIf
			
		EndIf
	Next
	
	
	WriteLine stream, "</table>"
	WriteLine stream, "<p>Results <b>"+results+"</b></p>"
	Footer(stream)
	
End Function



Function IslandSearch(stream,c_date,c_ocean,c_sector,c_isle,c_x_least,c_x_most,c_y_least,c_y_most,c_playerid,c_playername,c_playername_search,c_allianceid,c_alliancetag,c_inactive_least,c_inactive_most,c_develop_least,c_develop_most,c_distance_least,c_distance_most,v_date,v_ocean,v_sector,v_isle,v_x_least,v_x_most,v_y_least,v_y_most,v_playerid,v_playername$,v_playername_search$,v_allianceid,v_alliancetag$,v_inactive_least,v_inactive_most,v_develop_least,v_develop_most,v_distance_least,v_distance_most,v_distance_ocean,v_distance_sector,v_distance_isle,c_res,v_res,c_colod,c_moved,c_not_colod,c_not_moved)
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Search Islands
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	index = 0
	If c_date Then index = v_date ; for searching in history
	If index<0 Then index=0
	If index>last_data Then index=last_data

	Header(stream)
	WriteLine stream, "<h1>Island Search Results</h1>"
	WriteLine stream, "<h2>Parameters</h2>"
	
	WriteLine stream, "Day <b>"+index+"</b><br>Date <b>"+date$(index)+"</b><br>"
	If index >0 Then WriteLine stream, "<p style="+Chr(34)+"color:red"+Chr(34)+">This information is old. Use <b>Day 0</b> for the latest.</p>"
	
	If c_ocean Then WriteLine stream, "Ocean <b>"+v_ocean+"</b><br>"
	If c_sector Then WriteLine stream, "Sector <b>"+v_sector+"</b><br>"
	If c_isle Then WriteLine stream, "Isle <b>"+v_isle+"</b><br>"
	If c_x_least Then WriteLine stream, "X >= <b>"+v_x_least+"</b><br>"
	If c_x_most Then WriteLine stream, "X <= <b>"+v_x_most+"</b><br>"
	If c_y_least Then WriteLine stream, "Y >= <b>"+v_y_most+"</b><br>"
	If c_y_most Then WriteLine stream, "Y <= <b>"+v_y_most+"</b><br>"
	If c_playerid Then WriteLine stream, "Player ID <b>"+v_playerid +"</b><br>"
	If c_playername Then WriteLine stream, "Player name <b>"+v_playername$ +"</b><br>"
	If c_playername_search Then WriteLine stream, "Player name contains <b>"+v_playername_search$ +"</b><br>"
	If c_allianceid Then WriteLine stream, "Alliance ID <b>"+v_allianceid+"</b><br>"
	If c_alliancetag Then WriteLine stream, "Alliance tag <b>"+v_alliancetag$+"</b><br>"
	If c_inactive_least Then WriteLine stream, "Last active >= <b>"+v_inactive_least+"</b><br>"
	If c_inactive_most Then WriteLine stream, "Last active <= <b>"+v_inactive_most+"</b><br>"
	If c_develop_least Then WriteLine stream, "Points/isles >= <b>"+v_develop_least+"</b><br>"
	If c_develop_most Then WriteLine stream, "Points/isles <= <b>"+v_develop_most+"</b><br>"
	If c_distance_least Then WriteLine stream, "Distance from <b>"+v_distance_ocean+":"+v_distance_sector+":"+v_distance_isle+"</b> >= <b>"+v_distance_least+"</b><br>"
	If c_distance_most Then WriteLine stream, "Distance from <b>"+v_distance_ocean+":"+v_distance_sector+":"+v_distance_isle+"</b> <= <b>"+v_distance_most+"</b><br>"
	If c_colod Then WriteLine stream, "<b>Ruler changed</b><br>"
	If c_not_colod Then WriteLine stream, "<b>Ruler not changed</b><br>"
	If c_moved Then WriteLine stream, "<b>Alliance changed</b><br>"
	If c_not_moved Then WriteLine stream, "<b>Alliance not changed</b><br>"

	WriteLine stream, "<h2>Results</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
	WriteLine stream, "<tr>"
;	WriteLine stream, "<th>Day</th>"
;	WriteLine stream, "<th>Date</th>"
;	WriteLine stream, "<th>Ocean</th>"
;	WriteLine stream, "<th>Sector</th>"
	WriteLine stream, "<th>Isle</th>"
	WriteLine stream, "<th>X</th>"
	WriteLine stream, "<th>Y</th>"
	WriteLine stream, "<th>Player ID</th>"
	WriteLine stream, "<th>Player Name</th>"
	WriteLine stream, "<th>Alliance ID</th>"
	WriteLine stream, "<th>Alliance Tag</th>"
	WriteLine stream, "<th>Player Points/Isles</th>"	
	WriteLine stream, "<th>Player Inactive</th>"
;	WriteLine stream, "<th>Reports</th>"
	WriteLine stream, "<th>More Info</th>"

	For i.island = Each island ; loop players

		show = True ; mark player as matching parameters and can be shown	
	
	
		For p.player=Each player ; find owner info
			If p\id = i\rulerid[index]
				inactive = p\inactive[index] ;activity

				If p\islands[index] > 0 ;points-per-isle
					ppi = (p\score[index] / p\islands[index])
				Else
					ppi = 0
				EndIf
				
				Exit ;skip other players
			EndIf
		Next
		
		If c_distance_least Or c_distance_most ; distance
			ocean_r = (v_distance_ocean-1)Mod 5
			sector_r = (v_distance_sector-1)Mod 10
			isle_r = (v_distance_isle-1)Mod 10
			dx = 100*(ocean_r) + 10*(sector_r) + (isle_r)
			dy = ((v_distance_ocean-1)-ocean_r)*20 + ((v_distance_sector-1)-sector_r) + ((v_distance_isle-1)-isle_r)/10
			dx = i\x - dx
			dy = i\y - dy
		
			distance# = Sqr#((dx*dx)+(dy*dy))
		EndIf
		
		;ownership changes?
		ruler_change = False
		alliance_change = False
		If index<last_data Then
			If i\rulerid[index]<>i\rulerid[index+1] Then ruler_change = True
			If i\allianceid[index]<>i\allianceid[index+1] Then alliance_change = True
		EndIf
	
		If c_ocean And i\ocean<>v_ocean Then show = False
		If c_sector And i\sector<>v_sector Then show = False
		If c_isle And i\isle<>v_isle Then show = False
		If c_x_least And i\x<v_x_least Then show = False
		If c_x_most And i\x>v_x_most Then show = False
		If c_y_least And i\y<v_y_least Then show = False
		If c_y_most And i\y>v_y_most Then show = False
		If c_playerid And i\rulerid[index]<>v_playerid Then show = False
		If c_playername And Lower$(i\rulername$[index])<>v_playername$ Then show = False
		If c_playername_search And Instr(Lower$(i\rulername$[index]),v_playername$)=0 Then show = False
		If c_allianceid And i\allianceid[index]<>v_allianceid Then show = False
		If c_alliancetag And Lower$(i\alliancetag$[index])<>v_alliancetag Then show = False
		If c_inactive_least And inactive<v_inactive_least Then show = False
		If c_inactive_most And inactive>v_inactive_most Then show = False
		If c_develop_least And ppi<v_develop_least Then show = False
		If c_develop_most And ppi>v_develop_most Then show = False
		If c_distance_least And distance#<v_distance_least Then show = False
		If c_distance_most And distance#>v_distance_most Then show = False
		If c_colod And ruler_change=0 Then show = False
		If c_not_colod And ruler_change Then show = False
		If c_moved And alliance_change=0 Then show = False
		If c_not_moved And alliance_change Then show = False

		If show ; validated, show island
		
			If rows=TABLE_ROWS Then
				WriteLine stream, "</table>"
				WriteLine stream, "<br><br>"
				WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
				WriteLine stream, "<tr>"
;				WriteLine stream, "<th>Day</th>"
;				WriteLine stream, "<th>Date</th>"
;				WriteLine stream, "<th>Ocean</th>"
;				WriteLine stream, "<th>Sector</th>"
				WriteLine stream, "<th>Isle</th>"
				WriteLine stream, "<th>X</th>"
				WriteLine stream, "<th>Y</th>"
				WriteLine stream, "<th>Player ID</th>"
				WriteLine stream, "<th>Player Name</th>"
				WriteLine stream, "<th>Alliance ID</th>"
				WriteLine stream, "<th>Alliance Tag</th>"
				WriteLine stream, "<th>Player Points/Isles</th>"	
				WriteLine stream, "<th>Player Inactive</th>"
;				WriteLine stream, "<th>Reports</th>"
				WriteLine stream, "<th>More Info</th>"
				rows=0
			EndIf
			rows=rows+1
		
			WriteLine stream, "<tr>"
;			WriteLine stream, "<td>"+index+"</td>"
;			WriteLine stream, "<td>"+date$(index)+"</td>"
			WriteLine stream, "<td>"+i\ocean+":"+i\sector+":"+i\isle+"</td>"
			WriteLine stream, "<td>"+i\x+"</td>"
			WriteLine stream, "<td>"+i\y+"</td>"
			
			If ruler_change Then
				WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, i\rulerid[index]+"</td>"
			If ruler_change Then
				WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, i\rulername$[index]+"</td>"
			
			If alliance_change Then
				WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, i\AllianceID[index]+"</td>"
			If alliance_change Then
				WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, i\AllianceTag$[index]+"&nbsp;</td>"
			WriteLine stream, "<td>"+ppi+"</td>" 
			
			If inactive>=40
				WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCFF"+Chr(34)+">"
			ElseIf inactive>=20
				WriteLine stream, "<td bgcolor="+Chr(34)+"#FFFFCC"+Chr(34)+">"
			Else
				WriteLine stream, "<td>"
			EndIf
			WriteLine stream, inactive+"</td>"
			
			
			
			
;			;spy reports count
;			spycount = 0
;			;get user info (move pointer)
;			For u.user = Each user
;				If u\username$ = user$ Then
;					Exit
;				EndIf
;			Next			
;			For s.spy = Each spy
;				submit_player$="" : submit_alliance = 0
;				; get owner of report (move pointer)
;				For up.user = Each user
;					If up\id = s\submit Then
;						submit_player$ = up\username$
;						submit_alliance = up\allianceid
;						Exit
;					EndIf
;				Next
;				
;				;check authorisation to see report
;				auth = False
;				;owner
;				If u\id = s\submit Then
;					auth = True
;				;same alliance as owner
;				ElseIf u\allianceid <> 0 Then
;					If u\allianceid = submit_alliance Then
;						auth=True
;					EndIf
;				EndIf
;				;is public
;				If s\public = True Then auth = True
;			
;				If auth = True Then
;					If (s\ocean = i\ocean) And (s\sector = i\sector) And (s\isle = i\isle) Then spycount = spycount + 1
;				EndIf
;			Next
;			If spycount = 0 Then
;				WriteLine stream, "<td>&nbsp;</td>"
;			Else
;				WriteLine stream, "<td><a href="+Chr(34)+"findspy?o="+ i\ocean +"&amp;s="+ i\sector +"&amp;i="+ i\isle +Chr(34)+">"+spycount+" reports</a></td>"
;			EndIf
			
			
			
			
			WriteLine stream, "<td>"	
			WriteLine stream, "<a href="+Chr(34)+"history?ocean="+ i\ocean +"&amp;sector="+ i\sector +"&amp;isle="+ i\isle +Chr(34)+">History</a> "
			WriteLine stream, "<a href="+Chr(34)+"history?playerid="+ i\rulerid[index] +Chr(34)+">Player</a> "
			WriteLine stream, "<a href="+Chr(34)+"history?allianceid="+ i\allianceid[index] +Chr(34)+">Alliance</a> "
			WriteLine stream, "<a href="+Chr(34)+"calc?ocean="+ i\ocean +"&amp;sector="+ i\sector +"&amp;isle="+ i\isle +Chr(34)+">Distance</a> "
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/map/"+ i\ocean +"/"+ i\sector +Chr(34)+">Map</a> "
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/my/fleets/"+ i\ocean +"/"+ i\sector +"/"+ i\isle +Chr(34)+">Fleet</a>"
			WriteLine stream, "</td>"
		
		
			;count results
			results=results+1
			;cap results
			If c_res Then
				If results=v_res Then Exit
			EndIf
			
		EndIf
	Next

	WriteLine stream, "</table>"
	WriteLine stream, "<p>Results <b>"+results+"</b></p>"
	Footer(stream)

End Function




Function Graph(stream,mode) ;parameters passed through graph_id()
	
	;; graph dimensions
	graph_width = 600
	graph_height = 300
	maximum=0
	minimum=2147483647

	;; load data
	For k=0 To 5 ; loop compared
		If graph_id(k)>0 Then ; if selected
		
			If mode = 0 ;ALLIANCE GRAPH MODE
				For a.alliance = Each alliance ; loop alliances
					If a\id=graph_id(k) ; match alliance
						For index=0 To last_data ; loop records
							graph_data(k,index)=a\score[index] ; store score
							If graph_data(k,index)<minimum Then minimum=graph_data(k,index) ; set graph max
							If graph_data(k,index)>maximum Then maximum=graph_data(k,index) ; set graph max
						Next
					EndIf
				Next
				
			Else ;PLAYER GRAPH MODE
				For p.player = Each player ; loop players
					If p\id=graph_id(k) ; match player
						For index=0 To last_data ; loop records
							graph_data(k,index)=p\score[index] ; store score
							If graph_data(k,index)<minimum Then minimum=graph_data(k,index) ; set graph max
							If graph_data(k,index)>maximum Then maximum=graph_data(k,index) ; set graph max
						Next
					EndIf
				Next
				
			EndIf			
		EndIf
	Next
	
	x_border = FontHeight()
	y_border = FontWidth() * Len(Str maximum)
	
	;; create background
	background = CreateImage (1,2)
	SetBuffer ImageBuffer (background)
	Color 222,222,222 : Plot 0,0
	Color 211,211,211 : Plot 0,1
	
	;; create canvas
	image = CreateImage (graph_width+y_border,graph_height+x_border)
	SetBuffer ImageBuffer (image)	
	ClsColor 255,255,255
	Cls
	
	;; draw background
	Viewport y_border,0,graph_width,graph_height
	TileImage background
	Viewport 0,0,ImageWidth(image),ImageHeight(image)
	FreeImage background
	
	;; draw axes
	Color 0,0,0
	Line y_border,0,y_border,graph_height
	Line y_border,graph_height,y_border+graph_width,graph_height
	Text 0,0,maximum
	Text 0,graph_height-x_border,minimum
	Text y_border,graph_height,date$(last_data)
	Text graph_width+y_border-(FontWidth() * Len(Str date$(0))),graph_height,date$(0)
	
	x_scale# = 1.0 * graph_width/last_data ; x spacing
	y_scale# = 1.0 * graph_height/(maximum-minimum) ; y spacing
	
	;; draw graph
	For k=0 To 5 ; loop compared
		If graph_id(k)>0 Then ; if selected
		
			For index=last_data To 1 Step -1 ; loop records

				;; select colour
				Select k
				Case 0 : Color 255,0,0
				Case 1 : Color 255,128,0
				Case 2 : Color 0,255,0
				Case 3 : Color 0,255,255
				Case 4 : Color 0,0,255
				Case 5 : Color 255,0,255
				End Select
				
				;; plot
				x1# = graph_width - (index * x_scale#)
				y1# = graph_height - ((graph_data(k,index) - minimum) * y_scale#)
				x2# = graph_width - ((index - 1) * x_scale#)
				y2# = graph_height - ((graph_data(k,index-1) - minimum) * y_scale#)
								
				Line x1#+y_border,y1#,x2#+y_border,y2# ; draw line!
				Rect x1#+y_border-1,y1#-1,3,3,1 ;plot data point
;				Text x1#+y_border,y1#,graph_data(k,index) ; write value
				
			Next
		EndIf
	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function



Function PlayerWorldMap(stream,use_date) ; ids passed through graph_id()


	;create map
	image = CreateImage(500,500)
	SetBuffer ImageBuffer(image)
	ClsColor 255,255,255
	Cls
	
	;draw sectors
	For x=0 To 4
		For y=0 To 4
			Color 200,200,255
			Rect x*100,y*100,100,100,0
		Next
	Next
	
	;loop islands in this ocean
	For i.island = Each island

			;draw island fill
			Color 192,192,192
			Select i\rulerid[use_date]
			Case graph_id(0) : Color 255,0,0
			Case graph_id(1) : Color 255,127,0
			Case graph_id(2) : Color 0,255,0
			Case graph_id(3) : Color 0,255,255
			Case graph_id(4) : Color 0,0,255
			Case graph_id(5) : Color 255,0,255
			End Select
			Rect i\x, i\y, 1, 1, 1
			
	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function







Function AllianceWorldMap(stream,use_date) ; ids passed through graph_id()

	;create map
	image = CreateImage(500,500)
	SetBuffer ImageBuffer(image)
	ClsColor 255,255,255
	Cls
	
	;draw sectors
	For x=0 To 4
		For y=0 To 4
			Color 200,200,255
			Rect x*100,y*100,100,100,0
		Next
	Next
	
	;loop islands in this ocean
	For i.island = Each island
		
			;draw island fill
			Color 192,192,192
			Select i\allianceid[use_date]
			Case graph_id(0) : Color 255,0,0
			Case graph_id(1) : Color 255,127,0
			Case graph_id(2) : Color 0,255,0
			Case graph_id(3) : Color 0,255,255
			Case graph_id(4) : Color 0,0,255
			Case graph_id(5) : Color 255,0,255
			End Select
			Rect i\x, i\y, 1, 1, 1

	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function


Function PlayerOceanMap(stream,ocean,use_date) ; ids passed through graph_id()


	;create map
	image = CreateImage(500,500)
	SetBuffer ImageBuffer(image)
	ClsColor 255,255,255
	Cls
	
	;draw sectors
	For x=0 To 9
		For y=0 To 9
			Color 200,200,255
			Rect x*50,y*50,50,50,0
		Next
	Next
	
	;loop islands in this ocean
	For i.island = Each island
		If i\ocean = ocean
		
			;find local x and y
			sector_r = (i\sector-1)Mod 10
			isle_r = (i\isle-1)Mod 10
			x = 10*(sector_r) + (isle_r)
			y = ((i\sector-1)-sector_r) + ((i\isle-1)-isle_r)/10

			;draw island fill
			Color 255,255,255
			Select i\rulerid[use_date]
			Case graph_id(0) : Color 255,0,0
			Case graph_id(1) : Color 255,127,0
			Case graph_id(2) : Color 0,255,0
			Case graph_id(3) : Color 0,255,255
			Case graph_id(4) : Color 0,0,255
			Case graph_id(5) : Color 255,0,255
			End Select
			Rect x*5, y*5, 4, 4, 1
			
			;draw island border
			Color ColorRed()/2,ColorGreen()/2,ColorBlue()/2
			Rect x*5, y*5, 4, 4, 0
			
		EndIf
	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function







Function AllianceOceanMap(stream,ocean,use_date) ; ids passed through graph_id()

	;create map
	image = CreateImage(500,500)
	SetBuffer ImageBuffer(image)
	ClsColor 255,255,255
	Cls
	
	;draw sectors
	For x=0 To 9
		For y=0 To 9
			Color 200,200,255
			Rect x*50,y*50,50,50,0
		Next
	Next
	
	;loop islands in this ocean
	For i.island = Each island
		If i\ocean = ocean
		
			;find local x and y
			sector_r = (i\sector-1)Mod 10
			isle_r = (i\isle-1)Mod 10
			x = 10*(sector_r) + (isle_r)
			y = ((i\sector-1)-sector_r) + ((i\isle-1)-isle_r)/10

			;draw island fill
			Color 255,255,255
			Select i\allianceid[use_date]
			Case graph_id(0) : Color 255,0,0
			Case graph_id(1) : Color 255,127,0
			Case graph_id(2) : Color 0,255,0
			Case graph_id(3) : Color 0,255,255
			Case graph_id(4) : Color 0,0,255
			Case graph_id(5) : Color 255,0,255
			End Select
			Rect x*5, y*5, 4, 4, 1
			
			;draw island border
			Color ColorRed()/2,ColorGreen()/2,ColorBlue()/2
			Rect x*5, y*5, 4, 4, 0
			
		EndIf
	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function


Function PlayerSectorMap(stream,ocean,sector,use_date) ; ids passed through graph_id()

	;create map
	image = CreateImage(49,49)
	SetBuffer ImageBuffer(image)
	ClsColor 255,255,255
	Cls
	
	;loop islands in this ocean
	For i.island = Each island
		If i\ocean = ocean
			If i\sector = sector
			
				;find local x and y
				isle_r = (i\isle-1)Mod 10
				x = isle_r
				y = ((i\isle-1)-isle_r)/10
	
				;draw island fill
				Color 255,255,255
				Select i\rulerid[use_date]
				Case graph_id(0) : Color 255,0,0
				Case graph_id(1) : Color 255,127,0
				Case graph_id(2) : Color 0,255,0
				Case graph_id(3) : Color 0,255,255
				Case graph_id(4) : Color 0,0,255
				Case graph_id(5) : Color 255,0,255
				End Select
				Rect x*5, y*5, 4, 4, 1
				
				;draw island border
				Color ColorRed()/2,ColorGreen()/2,ColorBlue()/2
				Rect x*5, y*5, 4, 4, 0
			EndIf				
		EndIf
	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function

Function AllianceSectorMap(stream,ocean,sector,use_date) ; ids passed through graph_id()

;	;create background
;	background = CreateImage (1,2)
;	SetBuffer ImageBuffer (background)
;	Color 222,222,255 : Plot 0,0
;	Color 192,192,255 : Plot 0,1

	;create map
	image = CreateImage(49,49)
	SetBuffer ImageBuffer(image)
	ClsColor 255,255,255
	Cls
;	TileImage background
;	FreeImage background
	
	;loop islands in this ocean
	For i.island = Each island
		If i\ocean = ocean
			If i\sector = sector
			
				;find local x and y
				isle_r = (i\isle-1)Mod 10
				x = isle_r
				y = ((i\isle-1)-isle_r)/10
	
				;draw island fill
				Color 255,255,255
				Select i\allianceid[use_date]
				Case graph_id(0) : Color 255,0,0
				Case graph_id(1) : Color 255,127,0
				Case graph_id(2) : Color 0,255,0
				Case graph_id(3) : Color 0,255,255
				Case graph_id(4) : Color 0,0,255
				Case graph_id(5) : Color 255,0,255
				End Select
				Rect x*5, y*5, 4, 4, 1
				
				;draw island border
				Color ColorRed()/2,ColorGreen()/2,ColorBlue()/2
				Rect x*5, y*5, 4, 4, 0
			EndIf
		EndIf
	Next

	SendBitmap(stream, image) ; done! send image
	
	;; housekeeping
	SetBuffer FrontBuffer()
	FreeImage(image)

End Function


Function HistoryAllianceSearch(stream,id)
	Header(stream)

	For a.alliance = Each alliance 
		If a\id = id Then

			WriteLine stream, "<h1>Alliance History</h1>"
;			WriteLine stream, "<h2>Alliance ID "+id+"</h2>"
			WriteLine stream, "<h2>["+a\tag[0]+"]</h2>"
		
			WriteLine stream, "<a href="+Chr(34)+"arch?a="+ a\id +Chr(34)+">Full History</a><br><br>"
			
			WriteLine stream, "<a href="+Chr(34)+"alliancegraphpage?a0="+ a\tag[0] +Chr(34)+">Score Graph</a><br>"
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/alliances/show/"+ a\id +Chr(34)+">Profile</a><br>"
;			WriteLine stream, "<a href="+Chr(34)+"findspy?a="+ a\id +Chr(34)+">Reports</a>"
		
			WriteLine stream, "<h2>History</h2>"
			WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
			WriteLine stream, "<tr>"
			WriteLine stream, "<th>Day</th>"
			WriteLine stream, "<th>Date</th>"
			WriteLine stream, "<th>Alliance ID</th>"
			WriteLine stream, "<th>Alliance Tag</th>"
			WriteLine stream, "<th>Score</th>"
			WriteLine stream, "<th>Rank</th>"
			WriteLine stream, "<th>Members</th>"
			WriteLine stream, "<th>Islands</th>"
			WriteLine stream, "<th>Points/Players</th>"
			WriteLine stream, "<th>Inactive</th>"
			WriteLine stream, "<th>Member +/-</th>"
			WriteLine stream, "<th>Island +/-</th>"
			WriteLine stream, "<th>More Info</th>"

			For index=0 To last_data
			
				If rows=TABLE_ROWS Then
					WriteLine stream, "</table>"
					WriteLine stream, "<br><br>"
					WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
					WriteLine stream, "<tr>"
					WriteLine stream, "<th>Day</th>"
					WriteLine stream, "<th>Date</th>"
					WriteLine stream, "<th>Alliance ID</th>"
					WriteLine stream, "<th>Alliance Tag</th>"
					WriteLine stream, "<th>Score</th>"
					WriteLine stream, "<th>Rank</th>"
					WriteLine stream, "<th>Members</th>"
					WriteLine stream, "<th>Islands</th>"
					WriteLine stream, "<th>Points/Players</th>"
					WriteLine stream, "<th>Inactive</th>"
					WriteLine stream, "<th>Member +/-</th>"
					WriteLine stream, "<th>Island +/-</th>"
					WriteLine stream, "<th>More Info</th>"
					rows=0
				EndIf
				rows=rows+1
				
				If a\members[index] > 0 ;points-per-member
					ppp = (a\score[index] / a\members[index])
				Else
					ppp = 0
				EndIf
				
				WriteLine stream, "<tr>"
				WriteLine stream, "<td>"+index+"</td>"
				WriteLine stream, "<td>"+date$(index)+"</td>"
				WriteLine stream, "<td>"+a\id+"</td>"
				
;				If a\tag$[index]="" Then ;alliance disbanded / not formed yet
;					WriteLine stream, "<td>---</td>"
;				Else
					WriteLine stream, "<td>"+a\tag$[index]+"</td>"
;				EndIf		
				
				delta=0
				If index<last_data Then delta = a\score[index]-a\score[index+1]		
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"	
				WriteLine stream, a\score[index]+" ("+delta+")</td>"
	
				delta=0
				If index<last_data Then delta = a\rank[index]-a\rank[index+1]
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
				WriteLine stream, a\rank[index]+" ("+delta+")</td>"
	
				delta=0
				If index<last_data Then delta = a\members[index]-a\members[index+1]
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
				WriteLine stream, a\members[index]+" ("+delta+")</td>"
				
				delta=0
				If index<last_data Then delta = a\Islands[index]-a\Islands[index+1]
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
				WriteLine stream, a\Islands[index]+" ("+delta+")</td>"
			
				WriteLine stream, "<td>"+ppp+"</td>"
				
				WriteLine stream, "<td>"+a\inactive[index]+"</td>"

				WriteLine stream, "<td>"
				
				;MEMBER GAINS / LOSSES
				If index < last_data ;do not do for last entry in history
					For p.player = Each player ; loop players
						If p\allianceid[index] = a\id
							If p\allianceid[index+1] <> a\id ;gained member
								WriteLine stream, "<a href="+Chr(34)+"history?playerid="+p\id+Chr(34)+" style="+Chr(34)+"color:green"+Chr(34)+">"
								WriteLine stream, p\name$[index]+"</a>"
							EndIf
						Else
							If p\allianceid[index+1] = a\id ;lost member
								WriteLine stream, "<a href="+Chr(34)+"history?playerid="+p\id+Chr(34)+" style="+Chr(34)+"color:red"+Chr(34)+">"
								WriteLine stream, p\name$[index]+"</a>"
							EndIf
						EndIf
					Next
				EndIf				

				WriteLine stream, "&nbsp;</td>"
				WriteLine stream, "<td>"
				
				;ISLE GAINS / LOSSES
				If index < last_data ;do not do for last entry in history
					For i.island = Each island ; loop islands
						If i\allianceid[index] = a\id
							If i\allianceid[index+1] <> a\id ;gained isle
								WriteLine stream, "<a href="+Chr(34)+"history?ocean="+i\ocean+"&amp;sector="+i\sector+"&amp;isle="+i\isle+Chr(34)+" style="+Chr(34)+"color:green"+Chr(34)+">"
								WriteLine stream, i\ocean+":"+i\sector+":"+i\isle+"</a>"
							EndIf
						Else
							If i\allianceid[index+1] = a\id ;lost isle
								WriteLine stream, "<a href="+Chr(34)+"history?ocean="+i\ocean+"&amp;sector="+i\sector+"&amp;isle="+i\isle+Chr(34)+" style="+Chr(34)+"color:red"+Chr(34)+">"
								WriteLine stream, i\ocean+":"+i\sector+":"+i\isle+"</a>"
							EndIf
						EndIf
					Next
				EndIf				

				WriteLine stream, "&nbsp;</td>"
				
				WriteLine stream, "<td>"			
				WriteLine stream, "<a href="+Chr(34)+"player?check_date=&amp;date="+index+"&amp;check_allianceid=&amp;allianceid="+ a\id +Chr(34)+">Members</a> "
				WriteLine stream, "<a href="+Chr(34)+"island?check_date=&amp;date="+index+"&amp;check_allianceid=&amp;allianceid="+ a\id +Chr(34)+">Islands</a> "
				WriteLine stream, "<a href="+Chr(34)+"alliancemappage?ocean=&sector=&date="+index+"&a0="+a\tag$[index]+Chr(34)+">Map</a>"
				WriteLine stream, "</td>"
				
			Next	
			Exit		
		EndIf
	Next
	
	
	WriteLine stream, "</table>"
	Footer(stream)

End Function


Function HistoryPlayerSearch(stream,id)
	Header(stream)

	For p.player=Each player
		If p\id = id Then

			WriteLine stream, "<h1>Player History</h1>"
;			WriteLine stream, "<h2>Player ID "+id+"</h2>"
			WriteLine stream, "<h2>["+p\name[0]+"]</h2>"

			WriteLine stream, "<a href="+Chr(34)+"arch?p="+ p\id +Chr(34)+">Full History</a><br><br>"

			WriteLine stream, "<a href="+Chr(34)+"playergraphpage?a0="+ p\name[0] +Chr(34)+">Score Graph</a><br>"
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/players/"+ p\name[0] +Chr(34)+">Profile</a><br>"
			WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/my/messages/new?recipient="+ p\name[0] +Chr(34)+">Send Mail</a><br>"
;			WriteLine stream, "<a href="+Chr(34)+"findspy?p="+ p\id +Chr(34)+">Reports</a>"
			
			WriteLine stream, "<h2>History</h2>"
			WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
			WriteLine stream, "<tr>"
			WriteLine stream, "<th>Day</th>"
			WriteLine stream, "<th>Date</th>"
			WriteLine stream, "<th>Player ID</th>"
			WriteLine stream, "<th>Player Name</th>"
			WriteLine stream, "<th>Score</th>"
			WriteLine stream, "<th>Rank</th>"
			WriteLine stream, "<th>Alliance ID</th>"
			WriteLine stream, "<th>Alliance Tag</th>"
			WriteLine stream, "<th>Islands</th>"
			WriteLine stream, "<th>Points/Isles</th>"
			WriteLine stream, "<th>Inactive</th>"
			WriteLine stream, "<th>Island +/-</th>"
			WriteLine stream, "<th>More Info</th>"
	
			For index = 0 To last_data
			
				If rows=TABLE_ROWS Then
					WriteLine stream, "</table>"
					WriteLine stream, "<br><br>"
					WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
					WriteLine stream, "<tr>"
					WriteLine stream, "<th>Day</th>"
					WriteLine stream, "<th>Date</th>"
					WriteLine stream, "<th>Player ID</th>"
					WriteLine stream, "<th>Player Name</th>"
					WriteLine stream, "<th>Score</th>"
					WriteLine stream, "<th>Rank</th>"
					WriteLine stream, "<th>Alliance ID</th>"
					WriteLine stream, "<th>Alliance Tag</th>"
					WriteLine stream, "<th>Islands</th>"
					WriteLine stream, "<th>Points/Isles</th>"
					WriteLine stream, "<th>Inactive</th>"
					WriteLine stream, "<th>Island +/-</th>"
					WriteLine stream, "<th>More Info</th>"
					rows=0
				EndIf
				rows=rows+1
			
				If p\islands[index] > 0 ;points-per-isle
					ppi = (p\score[index] / p\islands[index])
				Else
					ppi = 0
				EndIf
				
				WriteLine stream, "<tr>"
				WriteLine stream, "<td>"+index+"</td>"
				WriteLine stream, "<td>"+date$(index)+"</td>"
				WriteLine stream, "<td>"+p\id+"</td>"
				
;				If p\name$[index]="" Then ;player not formed yet
;					WriteLine stream, "<td>---</td>"
;				Else
					WriteLine stream, "<td>"+p\name$[index]+"</td>"
;				EndIf

				delta=0
				If index<last_data Then delta = p\score[index]-p\score[index+1]	
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
				WriteLine stream, p\score[index]+" ("+delta+")</td>"
				
				delta=0
				If index<last_data Then delta = p\rank[index]-p\rank[index+1]	
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
				WriteLine stream, p\rank[index]+" ("+delta+")</td>"
				
				WriteLine stream, "<td>"+p\AllianceID[index]+"</td>"
				WriteLine stream, "<td>"+p\AllianceTag$[index]+"&nbsp;</td>"
				
				delta=0
				If index<last_data Then delta = p\Islands[index]-p\Islands[index+1]	
				If delta<0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#FFCCCC"+Chr(34)+">"
				If delta>0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFCC"+Chr(34)+">"
				If delta=0 Then	WriteLine stream, "<td bgcolor="+Chr(34)+"#CCCCFF"+Chr(34)+">"
				WriteLine stream, p\Islands[index]+" ("+delta+")</td>"

				WriteLine stream, "<td>"+ppi+"</td>" 
				
				WriteLine stream, "<td>"+p\inactive[index]+"</td>"
				
				WriteLine stream, "<td>"
				
				;ISLE GAINS / LOSSES
				If index < last_data ;do not do for last entry in history
					For i.island = Each island ; loop islands
						If i\rulerid[index] = p\id
							If i\rulerid[index+1] <> p\id ;gained isle
								WriteLine stream, "<a href="+Chr(34)+"history?ocean="+i\ocean+"&amp;sector="+i\sector+"&amp;isle="+i\isle+Chr(34)+" style="+Chr(34)+"color:green"+Chr(34)+">"
								WriteLine stream, i\ocean+":"+i\sector+":"+i\isle+"</a>"
							EndIf
						Else
							If i\rulerid[index+1] = p\id ;lost isle
								WriteLine stream, "<a href="+Chr(34)+"history?ocean="+i\ocean+"&amp;sector="+i\sector+"&amp;isle="+i\isle+Chr(34)+" style="+Chr(34)+"color:red"+Chr(34)+">"
								WriteLine stream, i\ocean+":"+i\sector+":"+i\isle+"</a>"
							EndIf
						EndIf
					Next
				EndIf				
				
				WriteLine stream, "&nbsp;</td>"
				WriteLine stream, "<td>"			
				WriteLine stream, "<a href="+Chr(34)+"history?allianceid="+ p\allianceid[index] +Chr(34)+">Alliance</a> "
				WriteLine stream, "<a href="+Chr(34)+"island?check_date=&amp;date="+index+"&amp;check_playerid=&amp;playerid="+ p\id +Chr(34)+">Islands</a> "
				WriteLine stream, "<a href="+Chr(34)+"playermappage?ocean=&sector=&date="+index+"&a0="+p\name$[index]+Chr(34)+">Map</a>"
				
				WriteLine stream, "</td>"
			Next
			Exit
		EndIf
	Next
		
	WriteLine stream, "</table>"
	Footer(stream)
End Function



Function HistoryIslandSearch(stream,ocean,sector,isle)
	Header(stream)
	WriteLine stream, "<h1>Island History</h1>"
	WriteLine stream, "<h2>Island "+ocean+":"+sector+":"+isle+"</h2>"
	
	WriteLine stream, "<a href="+Chr(34)+"arch?o="+ ocean +"&amp;s="+ sector +"&amp;i="+ isle +Chr(34)+">Full History</a><br><br>"
	
	WriteLine stream, "<a href="+Chr(34)+"calc?ocean="+ ocean +"&amp;sector="+ sector +"&amp;isle="+ isle +Chr(34)+">Distance Calculator</a><br>"
	WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/map/"+ ocean +"/"+ sector +Chr(34)+">Sector Map</a><br>"
	WriteLine stream, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/my/fleets/"+ ocean +"/"+ sector +"/"+ isle +Chr(34)+">Send Fleet Here</a><br>"
;	WriteLine stream, "<a href="+Chr(34)+"findspy?o="+ ocean +"&amp;s="+ sector +"&amp;i="+ isle +Chr(34)+">Reports</a>"
	
	WriteLine stream, "<h2>History</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Day</th>"
	WriteLine stream, "<th>Date</th>"
;	WriteLine stream, "<th>Ocean</th>"
;	WriteLine stream, "<th>Sector</th>"
	WriteLine stream, "<th>Isle</th>"
	WriteLine stream, "<th>X</th>"
	WriteLine stream, "<th>Y</th>"
	WriteLine stream, "<th>Player ID</th>"
	WriteLine stream, "<th>Player Name</th>"
	WriteLine stream, "<th>Alliance ID</th>"
	WriteLine stream, "<th>Alliance Tag</th>"
	WriteLine stream, "<th>Player Points/Isles</th>"	
	WriteLine stream, "<th>Player Inactive</th>"
	WriteLine stream, "<th>More Info</th>"
	
	For i.island = Each island ; loop players	
		If ocean=i\ocean And sector=i\sector And isle=i\isle
			For index = 0 To Last_Data

				If rows=TABLE_ROWS Then
					WriteLine stream, "</table>"
					WriteLine stream, "<br><br>"
					WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+">"
					WriteLine stream, "<tr>"
					WriteLine stream, "<th>Day</th>"
					WriteLine stream, "<th>Date</th>"
;					WriteLine stream, "<th>Ocean</th>"
;					WriteLine stream, "<th>Sector</th>"
					WriteLine stream, "<th>Isle</th>"
					WriteLine stream, "<th>X</th>"
					WriteLine stream, "<th>Y</th>"
					WriteLine stream, "<th>Player ID</th>"
					WriteLine stream, "<th>Player Name</th>"
					WriteLine stream, "<th>Alliance ID</th>"
					WriteLine stream, "<th>Alliance Tag</th>"
					WriteLine stream, "<th>Player Points/Isles</th>"	
					WriteLine stream, "<th>Player Inactive</th>"
					WriteLine stream, "<th>More Info</th>"
					rows=0
				EndIf
				rows=rows+1
				
				For p.player=Each player ; find owner info
					If p\id = i\rulerid[index]
						inactive = p\inactive[index] ;activity
		
						If p\islands[index] > 0 ;points-per-isle
							ppi = (p\score[index] / p\islands[index])
						Else
							ppi = 0
						EndIf
						
						Exit ;skip other players
					EndIf
				Next
				
				;ownership changes?
				ruler_change = False
				alliance_change = False
				If index<last_data Then
					If i\rulerid[index]<>i\rulerid[index+1] Then ruler_change = True
					If i\allianceid[index]<>i\allianceid[index+1] Then alliance_change = True
				EndIf
			
				WriteLine stream, "<tr>"
				WriteLine stream, "<td>"+index+"</td>"
				WriteLine stream, "<td>"+date$(index)+"</td>"
				WriteLine stream, "<td>"+i\ocean+":"+i\sector+":"+i\isle+"</td>"
				WriteLine stream, "<td>"+i\x+"</td>"
				WriteLine stream, "<td>"+i\y+"</td>"

				If ruler_change Then
					WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
				Else
					WriteLine stream, "<td>"
				EndIf
				WriteLine stream, i\rulerid[index]+"</td>"
				If ruler_change Then
					WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
				Else
					WriteLine stream, "<td>"
				EndIf
				WriteLine stream, i\rulername$[index]+"</td>"
				
				If alliance_change Then
					WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
				Else
					WriteLine stream, "<td>"
				EndIf
				WriteLine stream, i\AllianceID[index]+"</td>"
				If alliance_change Then
					WriteLine stream, "<td bgcolor="+Chr(34)+"#CCFFFF"+Chr(34)+">"
				Else
					WriteLine stream, "<td>"
				EndIf
				WriteLine stream, i\AllianceTag$[index]+"&nbsp;</td>"

				WriteLine stream, "<td>"+ppi+"</td>" 
				
				WriteLine stream, "<td>"+inactive+"</td>"
				
				WriteLine stream, "<td>"	
				WriteLine stream, "<a href="+Chr(34)+"history?playerid="+ i\rulerid[index] +Chr(34)+">Player</a> "
				WriteLine stream, "<a href="+Chr(34)+"history?allianceid="+ i\allianceid[index] +Chr(34)+">Alliance</a>"
				WriteLine stream, "</td>"
				
			Next
			Exit
		
		EndIf
	Next

	WriteLine stream, "</table>"
	Footer(stream)

End Function





Function CalcDistance(stream,o1,s1,i1,o2,s2,i2)
	
	;isle 1 coords
	o1_r = (o1-1)Mod 5
	s1_r = (s1-1)Mod 10
	i1_r = (i1-1)Mod 10
	x1 = 100*(o1_r) + 10*(s1_r) + (i1_r)
	y1 = ((o1-1)-o1_r)*20 + ((s1-1)-s1_r) + ((i1-1)-i1_r)/10

	;isle 2 coords
	o2_r = (o2-1)Mod 5
	s2_r = (s2-1)Mod 10
	i2_r = (i2-1)Mod 10
	x2 = 100*(o2_r) + 10*(s2_r) + (i2_r)
	y2 = ((o2-1)-o2_r)*20 + ((s2-1)-s2_r) + ((i2-1)-i2_r)/10

	;distance in NM
	deltax = x2 - x1
	deltay = y2 - y1
	distance# = Sqr# ((deltax * deltax) + (deltay * deltay))
	
	Header(stream)
	WriteLine stream, "<h1>Distance Calculator</h1>"
	
	WriteLine stream, "Source "+o1+":"+s1+":"+i1+"<br>"
	WriteLine stream, "Destination "+o2+":"+s2+":"+i2+"<br><br>"
	WriteLine stream, "<b>Distance "+distance#+" nautical miles</b><br>"

	WriteLine stream, "<h2>Travel Time</h2>"
	For speed = 1 To 6

		;time
		days = Floor((distance#/speed)/24.0)
		hours = Floor(distance#/speed) Mod 24
		minutes = Floor(60.0*distance#/speed) Mod 60
		seconds = Floor(3600.0*distance#/speed) Mod 60
		
		If days = 0 Then
			If hours = 0 Then 
				WriteLine stream, minutes + " minutes and " + seconds + " seconds at " + speed + " knots.<br>"
			Else
				WriteLine stream, hours + " hours, " + minutes + " minutes and " + seconds + " seconds at " + speed + " knots.<br>"
			EndIf
		Else
			WriteLine stream, days + " days, " + hours + " hours, " + minutes + " minutes and " + seconds + " seconds at " + speed + " knots.<br>"
		EndIf
	Next

	Footer(stream)

End Function



;Function UserList(stream)
;	Header(stream)
;	
;	WriteLine stream, "<h1>User List</h1>"
;	
;	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+"><tr><th>ID</th><th>Username</th><th>Password</th><th>Cookie</th>"
;	For u.user = Each user
;
;		If Len(u\pass$) = 6
;			WriteLine stream, "<tr style="+Chr(34)+"color:red"+Chr(34)+">"
;		Else
;			WriteLine stream, "<tr>"
;		EndIf
;		
;		WriteLine stream, "<td>"+u\id+"</td><td>"+u\username$+"</td><td>"+u\pass$+"</td><td>"+u\cookie$+"</td>"
;	Next
;	WriteLine stream, "</table>"
;	
;	Footer(stream)
;End Function



Function DatabaseStatistics(stream)

	For a.alliance = Each alliance
		a_count = a_count + 1
	Next
	
	For p.player = Each player
		p_count = p_count + 1
	Next
	
	For i.island = Each island
		i_count = i_count + 1
	Next

	Header(stream)
	WriteLine stream, "<h1>Database Info</h1>"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Days recorded</th>"
	WriteLine stream, "<th>First record</th>"
	WriteLine stream, "<th>Last record</th>"
	WriteLine stream, "<th>Alliances</th>"
	WriteLine stream, "<th>Players</th>"
	WriteLine stream, "<th>Islands</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>"
	WriteLine stream, (Last_Data+1)
	WriteLine stream, "</td>"
	WriteLine stream, "<td>"
	WriteLine stream, date$(last_data)
	WriteLine stream, "</td>"
	WriteLine stream, "<td>"
	WriteLine stream, date$(0)
	WriteLine stream, "</td>"
	WriteLine stream, "<td>"
	WriteLine stream, a_count
	WriteLine stream, "</td>"
	WriteLine stream, "<td>"
	WriteLine stream, p_count
	WriteLine stream, "</td>"
	WriteLine stream, "<td>"
	WriteLine stream, i_count
	WriteLine stream, "</td>"
	WriteLine stream, "</table>"
	Footer(stream)
End Function



Function SendBitmap(stream,image)

	WriteLine stream,"HTTP/1.1 200 OK"
	WriteLine stream,"Server: CuccosTools/"+VERSION$
;	ServerTime(stream)
;	WriteLine stream,"Last-Modified: "+last_modified$
;	WriteLine stream,"Expires: "+last_modified$
	WriteLine stream, "Connection: close"
;	WriteLine stream, "X-Powered-By: BlitzBasic/1.68"
	WriteLine stream,"Content-Type: image/bmp"
	WriteLine stream,""
	
	;padding
	width = ImageWidth(image)
	p_width = 4 * Floor# ((width * 3) / 4.0)
	If p_width < width * 3 Then p_width = p_width + 4
	pad = p_width - width * 3

	;filesize
	size=((ImageWidth(image)+pad)*ImageHeight(image)*3)
	;bitmap header size
	header=40
	;combined header size
	offset=54
	;pixels per metre
	pixpm=3780
	;bits per pixel
	bits=24
	
	
	;FILE HEADER
	WriteByte stream,Asc("B")
	WriteByte stream,Asc("M")
	WriteInt stream,(size+offset)
	WriteShort stream,0
	WriteShort stream,0
	WriteInt stream,offset
	
	;BITMAP HEADER
	WriteInt stream,header
	WriteInt stream,ImageWidth(image)
	WriteInt stream,ImageHeight(image)
	WriteShort stream,1
	WriteShort stream,bits
	WriteInt stream,0
	WriteInt stream,size
	WriteInt stream,pixpm
	WriteInt stream,pixpm
	WriteInt stream,0
	WriteInt stream,0
	
	;PIXEL DATA
	LockBuffer
	For y=ImageHeight(image)-1 To 0 Step -1
		For x=0 To ImageWidth(image)-1
			pixel = ReadPixelFast(x,y)

			WriteByte stream,(pixel And $000000FF)       ;blue
			WriteByte stream,(pixel And $0000FF00)/256   ;green
			WriteByte stream,(pixel And $00FF0000)/65536 ;red

		Next
		For p=0 To pad-1
			WriteByte stream,0
		Next
	Next
	UnlockBuffer
End Function



Function CalcBuild(stream,gold,stone,lumber,sws,sms,ws,ms,st,sf,ar,ca)

	Local level, rate#
	Local goldrate, stonerate, lumberrate, goldspend, stonespend, lumberspend
	Local harbourtime, barracktime, labtime

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Tables
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	Local BASE_GOLD_RATE = 8
	Local BASE_STONE_RATE = 5
	Local BASE_LUMBER_RATE = 6
	
	Local SWS_GOLD = 400, SWS_STONE = 0, SWS_LUMBER = 300, SWS_TIME = 11376
	Local SMS_GOLD = 300, SMS_STONE = 0, SMS_LUMBER = 450, SMS_TIME = 11376
	Local WS_GOLD = 900, WS_STONE = 0, WS_LUMBER = 800, WS_TIME = 28442
	Local MS_GOLD = 600, MS_STONE = 0, MS_LUMBER = 650, MS_TIME = 34131
	Local ST_GOLD = 100, ST_STONE = 150, ST_LUMBER = 50, ST_TIME = 3592
	Local SF_GOLD = 200, SF_STONE = 50, SF_LUMBER = 100, SF_TIME = 5119
	Local AR_GOLD = 250, AR_STONE = 50, AR_LUMBER = 50, AR_TIME = 4549
	Local CA_GOLD = 2000, CA_STONE = 3000, CA_LUMBER = 2000, CA_TIME = 68262
	
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Calculate
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;gold production
	rate# = BASE_GOLD_RATE
	For level = 1 To gold
		rate# = rate# * 1.2
	Next
	goldrate = Floor(rate#)
	
	;stone production
	rate# = BASE_STONE_RATE
	For level = 1 To stone
		rate# = rate# * 1.2
	Next
	stonerate = Floor(rate#)
	
	;lumber production
	rate# = BASE_LUMBER_RATE
	For level = 1 To lumber
		rate# = rate# * 1.2
	Next
	lumberrate = Floor(rate#)
	
	;sws costs
	goldspend = goldspend + (sws * SWS_GOLD)
	stonespend = stonespend + (sws * SWS_STONE)
	lumberspend = lumberspend + (sws * SWS_LUMBER)
	harbourtime = harbourtime + (sws * SWS_TIME)
	
	;sms costs
	goldspend = goldspend + (sms * sms_GOLD)
	stonespend = stonespend + (sms * sms_STONE)
	lumberspend = lumberspend + (sms * sms_LUMBER)
	harbourtime = harbourtime + (sms * sms_TIME)
	
	;ws costs
	goldspend = goldspend + (ws * ws_GOLD)
	stonespend = stonespend + (ws * ws_STONE)
	lumberspend = lumberspend + (ws * ws_LUMBER)
	harbourtime = harbourtime + (ws * ws_TIME)
	
	;ms costs
	goldspend = goldspend + (ms * ms_GOLD)
	stonespend = stonespend + (ms * ms_STONE)
	lumberspend = lumberspend + (ms * ms_LUMBER)
	harbourtime = harbourtime + (ms * ms_TIME)
	
	;st costs
	goldspend = goldspend + (st * st_GOLD)
	stonespend = stonespend + (st * st_STONE)
	lumberspend = lumberspend + (st * st_LUMBER)
	barracktime = barracktime + (st * st_TIME)
	
	;sf costs
	goldspend = goldspend + (sf * sf_GOLD)
	stonespend = stonespend + (sf * sf_STONE)
	lumberspend = lumberspend + (sf * sf_LUMBER)
	barracktime = barracktime + (sf * sf_TIME)
	
	;ar costs
	goldspend = goldspend + (ar * ar_GOLD)
	stonespend = stonespend + (ar * ar_STONE)
	lumberspend = lumberspend + (ar * ar_LUMBER)
	barracktime = barracktime + (ar * ar_TIME)
	
	;ca costs
	goldspend = goldspend + (ca * ca_GOLD)
	stonespend = stonespend + (ca * ca_STONE)
	lumberspend = lumberspend + (ca * ca_LUMBER)
	labtime = labtime + (ca * ca_TIME)
	
	
	
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Write output
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	Header(stream)
	WriteLine stream, "<h1>Schedule Planner</h1>"

	WriteLine stream, "<h2>Resource Generation</h2>"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Building</th><th>Level</th><th>Resources/Hour</th><th>Resources/Day</th><th>Consumed</th><th>Surplus</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Gold Mine</td>"
	WriteLine stream, "<td>"+gold+"</td>"
	WriteLine stream, "<td>"+goldrate+"</td>"
	WriteLine stream, "<td>"+(goldrate*24)+"</td>"
	WriteLine stream, "<td>"+goldspend+"</td>"
	If (goldrate*24)>goldspend Then
		WriteLine stream, "<td>"
	Else
		WriteLine stream, "<td style="+Chr(34)+"color:red"+Chr(34)+">"
	EndIf
	WriteLine stream, ((goldrate*24)-goldspend)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Stone Quarry</td>"
	WriteLine stream, "<td>"+stone+"</td>"
	WriteLine stream, "<td>"+stonerate+"</td>"
	WriteLine stream, "<td>"+(stonerate*24)+"</td>"
	WriteLine stream, "<td>"+stonespend+"</td>"
	If (stonerate*24)>stonespend Then
		WriteLine stream, "<td>"
	Else
		WriteLine stream, "<td style="+Chr(34)+"color:red"+Chr(34)+">"
	EndIf
	WriteLine stream, ((stonerate*24)-stonespend)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Lumber Mill</td>"
	WriteLine stream, "<td>"+lumber+"</td>"
	WriteLine stream, "<td>"+lumberrate+"</td>"
	WriteLine stream, "<td>"+(lumberrate*24)+"</td>"
	WriteLine stream, "<td>"+lumberspend+"</td>"
	If (lumberrate*24)>lumberspend Then
		WriteLine stream, "<td>"
	Else
		WriteLine stream, "<td style="+Chr(34)+"color:red"+Chr(34)+">"
	EndIf
	WriteLine stream, ((lumberrate*24)-lumberspend)+"</td>"
	WriteLine stream, "</table>"
	
	
	
	WriteLine stream, "<h2>Building Utilization</h2>"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Building</th><th>Queue Time</th><th>Free Time</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Barracks</td>"
	WriteLine stream, "<td>"+barracktime+"</td>"
	If barracktime<86400 Then
		WriteLine stream, "<td>"
	Else
		WriteLine stream, "<td style="+Chr(34)+"color:red"+Chr(34)+">"
	EndIf
	WriteLine stream, (86400-barracktime)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Laboratory</td>"
	WriteLine stream, "<td>"+labtime+"</td>"
	If labtime<86400 Then
		WriteLine stream, "<td>"
	Else
		WriteLine stream, "<td style="+Chr(34)+"color:red"+Chr(34)+">"
	EndIf
	WriteLine stream, (86400-labtime)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Harbour</td>"
	WriteLine stream, "<td>"+harbourtime+"</td>"
	If harbourtime<86400 Then
		WriteLine stream, "<td>"
	Else
		WriteLine stream, "<td style="+Chr(34)+"color:red"+Chr(34)+">"
	EndIf
	WriteLine stream, (86400-harbourtime)+"</td>"
	WriteLine stream, "</table>"
	
	

	WriteLine stream, "<h2>Unit Production</h2>"
	WriteLine stream, "<table border="+Chr$(34)+"1"+Chr$(34)+">"
	WriteLine stream, "<tr>"
	WriteLine stream, "<th>Unit</th><th>Number</th><th>Gold Each</th><th>Stone Each</th><th>Lumber Each</th><th>Time Each</th><th>Gold Total</th><th>Stone Total</th><th>Lumber Total</th><th>Time Total</th>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Small Warships</td>"
	WriteLine stream, "<td>"+sws+"</td>"
	WriteLine stream, "<td>"+SWS_GOLD+"</td>"
	WriteLine stream, "<td>"+SWS_STONE+"</td>"
	WriteLine stream, "<td>"+SWS_LUMBER+"</td>"
	WriteLine stream, "<td>"+SWS_TIME+"</td>"
	WriteLine stream, "<td>"+(sws*SWS_GOLD)+"</td>"
	WriteLine stream, "<td>"+(sws*SWS_STONE)+"</td>"
	WriteLine stream, "<td>"+(sws*SWS_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(sws*SWS_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Small Merchant Ships</td>"
	WriteLine stream, "<td>"+sms+"</td>"
	WriteLine stream, "<td>"+sms_GOLD+"</td>"
	WriteLine stream, "<td>"+sms_STONE+"</td>"
	WriteLine stream, "<td>"+sms_LUMBER+"</td>"
	WriteLine stream, "<td>"+sms_TIME+"</td>"
	WriteLine stream, "<td>"+(sms*sms_GOLD)+"</td>"
	WriteLine stream, "<td>"+(sms*sms_STONE)+"</td>"
	WriteLine stream, "<td>"+(sms*sms_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(sms*sms_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Warships</td>"
	WriteLine stream, "<td>"+ws+"</td>"
	WriteLine stream, "<td>"+ws_GOLD+"</td>"
	WriteLine stream, "<td>"+ws_STONE+"</td>"
	WriteLine stream, "<td>"+ws_LUMBER+"</td>"
	WriteLine stream, "<td>"+ws_TIME+"</td>"
	WriteLine stream, "<td>"+(ws*ws_GOLD)+"</td>"
	WriteLine stream, "<td>"+(ws*ws_STONE)+"</td>"
	WriteLine stream, "<td>"+(ws*ws_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(ws*ws_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Merchant Ships</td>"
	WriteLine stream, "<td>"+ms+"</td>"
	WriteLine stream, "<td>"+ms_GOLD+"</td>"
	WriteLine stream, "<td>"+ms_STONE+"</td>"
	WriteLine stream, "<td>"+ms_LUMBER+"</td>"
	WriteLine stream, "<td>"+ms_TIME+"</td>"
	WriteLine stream, "<td>"+(ms*ms_GOLD)+"</td>"
	WriteLine stream, "<td>"+(ms*ms_STONE)+"</td>"
	WriteLine stream, "<td>"+(ms*ms_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(ms*ms_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Stonethrowers</td>"
	WriteLine stream, "<td>"+st+"</td>"
	WriteLine stream, "<td>"+st_GOLD+"</td>"
	WriteLine stream, "<td>"+st_STONE+"</td>"
	WriteLine stream, "<td>"+st_LUMBER+"</td>"
	WriteLine stream, "<td>"+st_TIME+"</td>"
	WriteLine stream, "<td>"+(st*st_GOLD)+"</td>"
	WriteLine stream, "<td>"+(st*st_STONE)+"</td>"
	WriteLine stream, "<td>"+(st*st_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(st*st_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Spear Fighters</td>"
	WriteLine stream, "<td>"+sf+"</td>"
	WriteLine stream, "<td>"+sf_GOLD+"</td>"
	WriteLine stream, "<td>"+sf_STONE+"</td>"
	WriteLine stream, "<td>"+sf_LUMBER+"</td>"
	WriteLine stream, "<td>"+sf_TIME+"</td>"
	WriteLine stream, "<td>"+(sf*sf_GOLD)+"</td>"
	WriteLine stream, "<td>"+(sf*sf_STONE)+"</td>"
	WriteLine stream, "<td>"+(sf*sf_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(sf*sf_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Archers</td>"
	WriteLine stream, "<td>"+ar+"</td>"
	WriteLine stream, "<td>"+ar_GOLD+"</td>"
	WriteLine stream, "<td>"+ar_STONE+"</td>"
	WriteLine stream, "<td>"+ar_LUMBER+"</td>"
	WriteLine stream, "<td>"+ar_TIME+"</td>"
	WriteLine stream, "<td>"+(ar*ar_GOLD)+"</td>"
	WriteLine stream, "<td>"+(ar*ar_STONE)+"</td>"
	WriteLine stream, "<td>"+(ar*ar_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(ar*ar_TIME)+"</td>"
	WriteLine stream, "<tr>"
	WriteLine stream, "<td>Catapults</td>"
	WriteLine stream, "<td>"+ca+"</td>"
	WriteLine stream, "<td>"+ca_GOLD+"</td>"
	WriteLine stream, "<td>"+ca_STONE+"</td>"
	WriteLine stream, "<td>"+ca_LUMBER+"</td>"
	WriteLine stream, "<td>"+ca_TIME+"</td>"
	WriteLine stream, "<td>"+(ca*ca_GOLD)+"</td>"
	WriteLine stream, "<td>"+(ca*ca_STONE)+"</td>"
	WriteLine stream, "<td>"+(ca*ca_LUMBER)+"</td>"
	WriteLine stream, "<td>"+(ca*ca_TIME)+"</td>"
	WriteLine stream, "</table>"

	Footer(stream)
End Function


;Function NewSpy(http,ocean,sector,isle,report$,public)
;
;	;;add a new report
;	
;	;match island to database (move pointer)
;	For i.island = Each island
;		If i\ocean = ocean And i\sector = sector And i\isle = isle Then
;			found = True
;			Exit
;		EndIf
;	Next
;	
;	;not found island
;	If Not found Then
;		ErrorPage(http,"Island "+ocean+":"+sector+":"+isle+" not found. Please check coordinates.")
;		Return
;	EndIf
;	
;	;get user info (move pointer)
;	For u.user = Each user
;		If u\username$ = user$ Then
;			Exit
;		EndIf
;	Next
;	
;	;make a new report
;	s.spy = New spy
;		s\ocean = ocean
;		s\sector = sector
;		s\isle = isle
;		s\submit = u\id
;		s\rulerid = i\rulerid[0]
;		s\rulername$ = i\rulername$[0]
;		s\allianceid = i\allianceid[0]
;		s\alliancetag$ = i\alliancetag$[0]
;		s\date$ = CurrentDate()
;		s\report$ = Replace$( Replace$( Replace$( report$, "+", " " ), ">", "&gt;" ), "<", "&lt;" ) ; encode <> characters as identities and fix space
;		s\id$ = u\id+"_"+ocean+"_"+sector+"_"+isle+"_"+Replace$(s\date$," ","_")+"_"+MilliSecs()
;		s\public = public
;	
;	If SaveSpy() Then
;		SpyReports(http,-1,"",0,"",ocean,sector,isle)
;	Else
;		ErrorPage(http, "Could not open report file. Serious lossage." )
;	EndIf
;	
;End Function


;Function SpyReports(http,v_allianceid,v_alliancetag$,v_playerid,v_playername$,v_ocean,v_sector,v_isle)
;
;	;;display reports
;	
;	Header(http)
;	WriteLine http,"<h1>Reports</h1>"
;	WriteLine http,"<p><a href="+Chr(34)+"spy"+Chr(34)+">Find or add reports</a></p>"
;
;	WriteLine http,"<h2>Parameters</h2>"
;	If v_allianceid<>-1 Then WriteLine http,"alliance ID = <b>"+v_allianceid+"</b><br>"
;	If v_alliancetag$<>"" WriteLine http,"alliance tag = <b>"+v_alliancetag$+"</b><br>"
;	If v_playerid<>0 Then WriteLine http,"player ID = <b>"+v_playerid+"</b><br>"
;	If v_playername$<>"" Then WriteLine http,"player name = <b>"+v_playername$+"</b><br>"
;	If v_ocean<>0 Then WriteLine http,"ocean = <b>"+v_ocean+"</b><br>"
;	If v_sector<>0 Then WriteLine http,"sector = <b>"+v_sector+"</b><br>"
;	If v_isle<>0 Then WriteLine http,"isle = <b>"+v_isle+"</b><br>"
;
;	WriteLine http,"<h2>Results</h2>"
;
;	;get user info (move pointer)
;	For u.user = Each user
;		If u\username$ = user$ Then
;			Exit
;		EndIf
;	Next			
;
;	For s.spy = Each spy
;		
;		; get owner of report (move pointer)
;		submit_player$="" : submit_alliance = 0
;		For p.user = Each user
;			If p\id = s\submit Then
;				submit_player$ = p\username$
;				submit_alliance = p\allianceid
;				Exit
;			EndIf
;		Next
;		
;		;check authorisation to see report
;		auth = False
;		;owner
;		If u\id = s\submit Then
;			auth = True
;		;same alliance as owner
;		ElseIf u\allianceid <> 0 Then
;			If u\allianceid = submit_alliance Then
;				auth=True
;			EndIf
;		EndIf
;		;is public
;		If s\public = True Then auth = True
;		
;			
;		If auth = True
;			
;			;apply filters
;			show = True
;			If v_allianceid<>-1 And v_allianceid<>s\allianceid Then show = False
;			If v_alliancetag$<>"" And Lower$(v_alliancetag$)<>Lower$(s\alliancetag$) Then show = False
;			If v_playerid<>0 And v_playerid<>s\rulerid Then show = False
;			If v_playername$<>"" And Lower$(v_playername$)<>Lower$(s\rulername$) Then show = False
;			If v_ocean<>0 And v_ocean<>s\ocean Then show = False
;			If v_sector<>0 And v_sector<>s\sector Then show = False
;			If v_isle<>0 And v_isle<>s\isle Then show = False
;			
;			If show = True
;			
;				WriteLine http,"<br><table width="+Chr$(34)+"100%"+Chr$(34)+" bgcolor="+Chr$(34)+"#DDDDDD"+Chr$(34)+">"
;				WriteLine http,"<tr><th>Date</th>"
;				WriteLine http,"<td>"+s\date$+"</td>"
;
;				WriteLine http,"<tr><th width="+Chr$(34)+"10%"+Chr$(34)+">Island</th>"
;				WriteLine http,"<td>"+s\ocean+":"+s\sector+":"+s\isle+" <a href="+Chr(34)+"findspy?o="+ s\ocean +"&amp;s="+ s\sector +"&amp;i="+ s\isle +Chr(34)+">Reports</a> "
;				WriteLine http, "<a href="+Chr(34)+"history?ocean="+ s\ocean +"&amp;sector="+ s\sector +"&amp;isle="+ s\isle +Chr(34)+">History</a> "
;;				WriteLine http, "<a href="+Chr(34)+"history?playerid="+ s\rulerid +Chr(34)+">Player</a> "
;				WriteLine http, "<a href="+Chr(34)+"history?allianceid="+ s\allianceid +Chr(34)+">Alliance</a> "
;				WriteLine http, "<a href="+Chr(34)+"calc?ocean="+ s\ocean +"&amp;sector="+ s\sector +"&amp;isle="+ s\isle +Chr(34)+">Distance</a> "
;				WriteLine http, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/map/"+ s\ocean +"/"+ s\sector +Chr(34)+">Map</a> "
;				WriteLine http, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/my/fleets/"+ s\ocean +"/"+ s\sector +"/"+ s\isle +Chr(34)+">Fleet</a>"
;				WriteLine http, "</td>"
;				
;				WriteLine http,"<tr><th>Ruler</th>"
;				WriteLine http,"<td>"+s\rulername$+" <a href="+Chr(34)+"findspy?p="+ s\rulerid +Chr(34)+">Reports</a> "
;				WriteLine http, "<a href="+Chr(34)+"history?playerid="+ s\rulerid +Chr(34)+">History</a> "
;				WriteLine http, "<a href="+Chr(34)+"playergraphpage?a0="+ s\rulername$ +Chr(34)+">Graph</a> "
;;				WriteLine http, "<a href="+Chr(34)+"history?allianceid="+ s\allianceid +Chr(34)+">Alliance</a> "
;				WriteLine http, "<a href="+Chr(34)+"island?check_date=&amp;date=0&amp;check_playerid=&amp;playerid="+ s\rulerid +Chr(34)+">Islands</a> "
;				WriteLine http, "<a href="+Chr(34)+"playermappage?ocean=&sector=&date=0&a0="+s\rulername$+Chr(34)+">Map</a> "
;				WriteLine http, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/players/"+ s\rulername +Chr(34)+">Profile</a>"
;				WriteLine http, "</td>"
;
;				WriteLine http,"<tr><th>Alliance</th>"
;				WriteLine http,"<td>"+s\alliancetag$+" <a href="+Chr(34)+"findspy?a="+ s\allianceid +Chr(34)+">Reports</a> "
;				WriteLine http, "<a href="+Chr(34)+"history?allianceid="+ s\allianceid +Chr(34)+">History</a> "
;				WriteLine http, "<a href="+Chr(34)+"alliancegraphpage?a0="+ s\alliancetag$ +Chr(34)+">Graph</a> "
;				WriteLine http, "<a href="+Chr(34)+"player?date=0&amp;allianceid="+ s\allianceid +Chr(34)+">Members</a> "
;				WriteLine http, "<a href="+Chr(34)+"island?date=0&amp;allianceid="+ s\allianceid +Chr(34)+">Islands</a> "
;				WriteLine http, "<a href="+Chr(34)+"alliancemappage?ocean=&sector=&date=0&a0="+s\alliancetag$+Chr(34)+">Map</a> "
;				WriteLine http, "<a href="+Chr(34)+"http://h728.serverid.net/inselkampf/alliances/show/"+ s\allianceid +Chr(34)+">Profile</a>"
;				WriteLine http, "</td>"
;			
;				WriteLine http,"<tr><th>Report</th>"
;				WriteLine http,"<td bgcolor="+Chr$(34)+"#FFFFFF"+Chr$(34)+"><pre>"+ s\report$ +"</pre></td>"
;				WriteLine http,"<tr><th>Submitted</th>"
;				WriteLine http,"<td>"+submit_player$
;				If s\public = True Then WriteLine http," (Public)"
;				If u\id = s\submit Then WriteLine http," <a href="+Chr(34)+"deletespy?"+ s\id$ +Chr(34)+">Delete!</a>
;				WriteLine http,"</td></table><br>"
;				
;			EndIf			
;		EndIf
;	Next
;		
;	Footer(http)
;End Function

;Function SpyDelete(stream, id$)
;
;		For s.spy = Each spy
;			If s\id = id
;		
;				; get owner of report (move pointer)
;				For p.player = Each player
;					If p\id = s\submit Then
;						submit_player$ = p\name$[0]
;						submit_alliance = p\allianceid[0]
;						Exit
;					EndIf
;				Next
;				
;				;get user info (move pointer)
;				For u.user = Each user
;					If u\username$ = user$ Then
;						Exit
;					EndIf
;				Next
;		
;				;check authorisation to see report
;				auth = False
;				;owner
;				If u\id = s\submit Then
;					auth = True
;;				;same alliance as owner
;;				ElseIf u\allianceid <> 0 Then
;;					If u\allianceid = submit_alliance Then
;;						auth=True
;;					EndIf
;				EndIf
;				;is public
;;				If s\public = True Then auth = True
;				
;				
;				If auth=True
;				
;					;delete report
;					Delete s
;					SpyPage(stream)
;					SaveSpy()
;					Return True
;					
;				EndIf
;				
;			EndIf
;		Next
;		
;		Errorpage(stream,"Report not found or not authorised")
;		
;End Function


Function ArchiveIsland(stream,o,s,i)
	Local index
	Header(stream)
	WriteLine stream, "<h1>Archive</h1>"
	WriteLine stream, "<h2>Island "+o+":"+s+":"+i+"</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+"><tr><th>Index</th><th>RulerID</th><th>RulerName$</th><th>AllianceID</th><th>AllianceTag$</th>"
	While ReadIsland(stream,o,s,i,index)
		index=index+1
	Wend
	WriteLine stream, "</table>"
	Footer(stream)
End Function


Function ArchiveAlliance(stream,a)
	Local index
	Header(stream)
	WriteLine stream, "<h1>Archive</h1>"
	WriteLine stream, "<h2>Alliance "+a+"</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+"><tr><th>Index</th><th>Tag$</th><th>Score</th><th>Rank</th><th>Members</th><th>Islands</th>"
	While ReadAlliance(stream,a,index)
		index=index+1
	Wend
	WriteLine stream, "</table>"
	Footer(stream)
End Function


Function ArchivePlayer(stream,p)
	Local index
	Header(stream)
	WriteLine stream, "<h1>Archive</h1>"
	WriteLine stream, "<h2>Player "+p+"</h2>"
	WriteLine stream, "<table border="+Chr(34)+"1"+Chr(34)+"><tr><th>Index</th><th>Name$</th><th>Islands</th><th>Score</th><th>Rank</th><th>AllianceID</th><th>AllianceTag$</th>"
	While ReadPlayer(stream,p,index)
		index=index+1
	Wend
	WriteLine stream, "</table>"
	Footer(stream)
End Function